
.set	pcbver,#3	; 1 = right arrows, 2 = left arrows, 3 = left 45 degrees
; <editor-fold desc="config">

.global __reset

.include "p24EP512GP202.inc"
	config __FICD, 0b00000001	; pgec3, pged3
	config __FPOR, 0b00000000	;
	config __FWDT, 0b00111111	; pll lock
	config __FOSC, 0b00100101	; ckswoff, XT
	config __FOSCSEL, 0b10000011	; FRCstart, XT+PLL
	config __FGS, 0b00000011	; no protect

; </editor-fold>
; <editor-fold desc="EQUs">
;------------------------------------------------------------------------------

.equ	HORSYNC,#286	; horizontal sync offset (higher value = earlier horizontal sync)
.equ	HORPOS,#42	; horizontal picture offset relative to markers for monitor auto adjustment
.equ	MARKERPOS,#22	; vert offset za markere za monitor auto adjustmenty RELATIVE TO SYNC (T1)
.equ	FRAMEPOS,#55	; vert offset za glavni frame RELATIVE TO SYNC (T1)
.equ	TEXTPOS,#563	; vert offset za donji tekst RELATIVE TO SYNC (T1)

.include "macros.inc"

;------------------------------------------------------------------------------
; </editor-fold>
.bss
; <editor-fold desc="RAM def">

;	  total RAM   49152
;	- bkgnd       46800
;         ostaje    =  2352
;	- stack         128
;       - spritebuf     180
;         ostaje    =  2044

			 ; this area is not cleared at warm start, but preset at cold start (power on)
MUSIC:		.space 2   ; 0=Jumping Jack Flash, 1=Golden Brown, 2=??? (pokazuje sa kao 1, 2, 3)
MUSICSOUNDS:	.space 2   ; 0=off, 1=low, 2=hi
JACKSSOUNDS:	.space 2   ; 0=off, 1=low, 2=hi
OTHERSOUNDS:	.space 2   ; 0=off, 1=low, 2=hi
ROTATEJOY:	.space 2   ; 0=No, 1=Yes (only in menu screen, does not affect game)
ROTATEFINAL:	.space 2   ; 0=No, 1=Yes (affects game)

CSCLR:		.space 0 ; start of memory cleared at cold start (power on)
MUSICPAGE:	.space 2   ; pointer citanja tonova za muziku iz tabele (page)
MUSICPTR:	.space 2   ; pointer citanja tonova za muziku iz tabele
MUSICPERIOD:	.space 2   ; brojac zadatog trajanja jednog tona za muziku
VGATASK:	.space 2   ; 0=vert sync, 1=markers, 2=main frame, 3=bottom text
CEKALICA:	.space 2   ; countdown for new game (0,5 sec kbd disable)
SEED:		.space 6   ; rnd reg
RNDACC: 	.space 6   ; rnd reg

WSCLR:		.space 0 ; start of memory cleared at warm start (game over)
FLAG:		.space 2 ; bit 0 = VGA frame handshaking
			 ; bit 1 = set if hit by enemy, reset if dropped thru hole
			 ; bit 2 = toggler za linecount
			 ; bit 3 = flag da treba usporiti Jacka 2x
			 ; bit 4 = flag da treba usporiti celu radnju 2x
			 ; bit 5 = za usporavanje Jacka 2x
			 ; bit 6 = za usporavanje cele radnje 2x
			 ; bit 7 = FALL flag (setovati za pad, automatski se resetuje)
			 ; bit 8 = set ako je pad poceo dok lezi
			 ; bit 9 = set signifies collision during jump
			 ; bit 10 = set ako je jack u liftu (bilo kom)
			 ; bit 11 = da Jack treba da prati lift dok se spusta
			 ; bit 12 = light in elevator 1
			 ; bit 13 = light in elevator 2
			 ; bit 14 = ufo present
			 ; bit 15 = shield on

F2:		.space 2 ; bit 0 = signifies collision during jump in SHIELD state
			 ; bit 1 = prethodno stanje FLAG,#10 (za detekciju trenutka ulaska u lift)
			 ; bit 2 = ufo beep present, shut it off in next cycle
			 ; bit 3 = set ako treba da postoji oblak
			 ; bit 4 = set ako je jack u oblaku
			 ; bit 5 = set ako je adjust screen
			 ; bit 6 = set ako su vec bile fanfare
			 ; bit 7 = set ako je congratulations
			 ; bit 8 = set ako je game over (0 lives)
			 ; bit 9 = set ako je vec detektovao bar jedan edge na kbd
			 ; bit 10 = set ako je upravo dobio zivot od CUBE LEFT, da se ne ponovi
			 ; bit 11 = set ako je upravo dobio zivot od CUBE RIGHT, da se ne ponovi


FA:		.space 2 ; bit 0 = set ako je akrep NOGE LEFT (zdesna nalevo) u akciji
			 ; bit 1 = set ako je akrep NOGE RIGHT (sleva nadesno) u akciji
			 ; bit 2 = set ako je catterpillar LEFT u akciji
			 ; bit 3 = set ako je catterpillar RIGHT u akciji
			 ; bit 4 = set ako je pogo LEFT u akciji
			 ; bit 5 = set ako je pogo RIGHT u akciji
			 ; bit 6 = set ako je paramecium LEFT u akciji
			 ; bit 7 = set ako je paramecium RIGHT u akciji
			 ; bit 8 = set ako je lightning LEFT u akciji
			 ; bit 9 = set ako je lightning RIGHT u akciji
			 ; bit 12 = set ako je cube LEFT u akciji
			 ; bit 13 = set ako je cube RIGHT u akciji
			 ; bit 15 = set ako je VERTICAL ENEMY u akciji


RUPE:			.space 32  ; max 8 holes, +0: hole X-pos 0...173 (>173: no hole), +2: line number 0...5 (>5: no hole)
BROJRUPA:		.space 2   ; koliko rupa je aktivno (0...8)
RUPASTOP:		.space 2   ; rupa koja miruje 0...8 (0=nijedna)
COPYLISTCOUNT:	.space 2   ; koliko je clanova u COPYLIST
JACKX:			.space 2   ; X pos Jacka
JACKY:			.space 2   ; Y pos Jacka (zaokruzena na visinu sprata)
REALY:			.space 2   ; prava Y pos Jacka, koja uzima u obzir i padove i skokove
JACKFLOOR:		.space 2   ; sprat na kome se nalazi Jack (0=skroz dole)
JACKMOVE:		.space 2   ; #0 set: Jack moves left, #1 set: Jack moves right
SPRITECOUNT:	.space 2   ; brojac faze pokreta
PLAYPTR:		.space 2   ; brojac sekvence za cesanje po glavi dok stoji
PLAYPTRJUMP:	.space 2   ; brojac sekvence za skok
PLAYPTRFALL:	.space 2   ; brojac sekvence za pad
PLAYPTRDOWN:	.space 2   ; brojac sekvence za silazak
PLAYPTRFALLSH:	.space 2   ; brojac sekvence za mali pad pod stitom
LASTSEED:		.space 2   ; tu pamti poslednji seed za cesanje po glavi
VGAUNIFORM:		.space 2   ; uniformni brojac (stalno broji na 54 Hz) 0...65535
DEBUGPTR:		.space 2   ; ptr upisa hex registara u BOTTOMTXT
SHIELDTIME:		.space 2   ; koliko dugo ceka shield (menja se za visno od LEVEL, tabela RATERUPE)
STEADY:			.space 2   ; koliko dugo nosi shield (menja se za visno od LEVEL, tabela RATERUPE)
SPIDERCOUNT:	.space 2  ; up/down brojac za skok na plafon 0...8 (ako je >0 onda nije na zemlji)

AUXSTOP:	.space 12  ; X pozicije svih znakova (ovde se randomizuju pa se posle prepisuju u STOPxX)
STOP6X:		.space 2   ; X pozicija znaka 6 (donji sprat) (0=ne postoji znak)	/vezano\
STOP5X:		.space 2   ; X pozicija znaka 5 (0=ne postoji znak)			|vezano|
STOP4X:		.space 2   ; X pozicija znaka 4 (0=ne postoji znak)			|vezano|
STOP3X:		.space 2   ; X pozicija znaka 3 (0=ne postoji znak)			|vezano|
STOP2X:		.space 2   ; X pozicija znaka 2 (0=ne postoji znak)			|vezano|
STOP1X:		.space 2   ; X pozicija znaka 1 (gornji sprat) (0=ne postoji znak)	\vezano/

; elevators control block
LIFT1Y:		.space 2   ; Y pos (odozgo) levog lifta
LIFT2Y:		.space 2   ; Y pos (odozgo) desnog lifta
LIFT1TARGET:	.space 2   ; Y pos zadate visine za levi lift
LIFT2TARGET:	.space 2   ; Y pos zadate visine za desni lift
LIFTPATIENCE:	.space 2   ; patience autostart counter (any elevator)

; enemies control block
UFOCOUNT:	.space 2   ; uniformni brojac za animaciju ufo-a
UFOVANISH:	.space 2   ; visina (od gornje ivice) na kojoj ce ufo da nestane
UFOX:		.space 2   ; X pos UFO
UFOY:		.space 2   ; Y pos UFO
UFOSTEADY:	.space 2   ; tajmer za mirovanje UFO na spratu
UFOTIMER:	.space 2   ; tajmer za trajanje shielda
UFOSOUNDCOUNT:	.space 2   ; counter for ufo sounds generation, will generate beep on =0 and silence on =1
NOGELCOUNT:	.space 2   ; uniformni brojac za animaciju nogu LEFT (zdesna nalevo)
NOGELX:		.space 2   ; X pos NOGE left (zdesna nalevo)
NOGELY:		.space 2   ; Y pos NOGE left (zdesna nalevo)
NOGELSPRAT:	.space 2   ; adresa sprata na kome je nogel + zauzeti
NOGERCOUNT:	.space 2   ; uniformni brojac za animaciju nogu RIGHT (sleva nadesno)
NOGERX:		.space 2   ; X pos NOGE right (sleva nadesno)
NOGERY:		.space 2   ; Y pos NOGE right (sleva nadesno)
NOGERSPRAT:	.space 2   ; adresa sprata na kome je noger + zauzeti
PILLARLCOUNT:	.space 2   ; brojac za gusenicu nalevo
PILLARLX:	.space 2   ; X pos za gusenicu nalevo
PILLARLY:	.space 2   ; Y pos za gusenicu nalevo
PLSPRAT:	.space 2   ; adresa sprata na kome je pillar left + zauzeti
PILLARRCOUNT:	.space 2   ; brojac za gusenicu nadesno
PILLARRX:	.space 2   ; X pos za gusenicu nadesno
PILLARRY:	.space 2   ; Y pos za gusenicu nadesno
PRSPRAT:	.space 2   ; adresa sprata na kome je pillar right + zauzeti
PGLCOUNT:	.space 2   ; brojac za pogo nalevo
POGOLX:		.space 2   ; X pos za pogo nalevo
POGOLY:		.space 2   ; Y pos za pogo nalevo
PGLSPRAT:	.space 2   ; adresa sprata na kome je pogo left + zauzeti
PGRCOUNT:	.space 2   ; brojac za pogo nadesno
POGORX:		.space 2   ; X pos za pogo nadesno
POGORY:		.space 2   ; Y pos za pogo nadesno
PGRSPRAT:	.space 2   ; adresa sprata na kome je pogo right + zauzeti
PARALCOUNT:	.space 2   ; brojac za paramecium nalevo
PARALX:		.space 2   ; X pos za paramecium nalevo
PARALY:		.space 2   ; Y pos za paramecium nalevo
PARALSPRAT:	.space 2   ; adresa sprata na kome je paramecium left + zauzeti
PARARCOUNT:	.space 2   ; brojac za paramecium nadesno
PARARX:		.space 2   ; X pos za paramecium nadesno
PARARY:		.space 2   ; Y pos za paramecium nadesno
PARARSPRAT:	.space 2   ; adresa sprata na kome je paramecium right + zauzeti
LIGLCOUNT:	.space 2   ; brojac za lightning nalevo
LIGLX:		.space 2   ; X pos za lightning nalevo
LIGLY:		.space 2   ; Y pos za lightning nalevo
LIGLSPRAT:	.space 2   ; adresa sprata na kome je lightning right + zauzeti
LIGLLAST:	.space 2   ; last lighting sprite left
LIGRCOUNT:	.space 2   ; brojac za lightning nadesno
LIGRX:		.space 2   ; X pos za lightning nadesno
LIGRY:		.space 2   ; Y pos za lightning nadesno
LIGRSPRAT:	.space 2   ; adresa sprata na kome je lightning right + zauzeti
LIGRLAST:	.space 2   ; last lightning sprite right

CUBELCOUNT:	.space 2   ; brojac za cube nalevo
CUBELX:		.space 2   ; X pos za cube nalevo
CUBELY:		.space 2   ; Y pos za cube nalevo
CUBELSPRAT:	.space 2   ; adresa sprata na kome je cube left + zauzeti
CUBERCOUNT:	.space 2   ; brojac za cube nadesno
CUBERX:		.space 2   ; X pos za cube nadesno
CUBERY:		.space 2   ; Y pos za cube nadesno
CUBERSPRAT:	.space 2   ; adresa sprata na kome je cube right + zauzeti

VERTX:		.space 2   ; X pos for vertical enemy
VERTY:		.space 2   ; Y pos for vertical enemy
VERTCOUNT:	.space 2   ; vertical enemy counter
VERTENEMY:	.space 2   ; vertical enemy 0=meteor, 1=teg, 
VERTINNER:	.space 2   ; vertical inner count


RATE:		.space 2   ; verovatnoca pojavljivanja horizontalnog akrepa, 1=na 1s, 2=na 2s, itd
VERTRATE:		.space 2   ; verovatnoca pojavljivanja vertikalnog akrepa, 1=na 1s, 2=na 2s, itd
CUBERATE:		.space 2   ; verovatnoca pojavljivanja kocke, 1=na 1s, 2=na 2s, itd
SHIELDRATE:		.space 2   ; verovatnoca pojavljivanja shielda, 1=na 1s, 2=na 2s, itd
EFFECT1PAGE:	.space 2   ; 1. pointer citanja tonova za tonske efekate iz tabele (page)
EFFECT1PTR:	.space 2   ; 1. pointer citanja tonova za tonske efekate iz tabele
EFFECT1PERIOD:	.space 2   ; 1. brojac zadatog trajanja jednog tona za tonske efekate
EFFECT2PAGE:	.space 2   ; 2. pointer citanja tonova za tonske efekate iz tabele (page)
EFFECT2PTR:	.space 2   ; 2. pointer citanja tonova za tonske efekate iz tabele
EFFECT2PERIOD:	.space 2   ; 2. brojac zadatog trajanja jednog tona za tonske efekate
ZAUZETI:	.space 8   ; koji spratovi su trenutno zauzeti akrepima (0=free)
TEXTX:		.space 2   ; X pos teksta
TEXTY:		.space 2   ; Y pos teksta
PAPER:		.space 2   ; boja pozadine za tekst (IIBBGGRR)	/vezano\ (ovo se presetuje pre stampanja teksta)
INKPAPER:	.space 2   ; 1.pix ink, 2.pix paper (IIBBGGRR)	|vezano| (ovo automatski racuna print sabrutina)
PAPERINK:	.space 2   ; 1.pix paper, 2.pix ink (IIBBGGRR)	|vezano| (ovo automatski racuna print sabrutina)
INK:		.space 2   ; boja pozadine za tekst (IIBBGGRR)	\vezano/ (ovo se presetuje pre stampanja teksta)
SHOWLEVELCOUNT:	.space 2   ; countdown za pokazivanje nivoa na ekranu
KEYROTORS:	.space 12  ; keyboard debouncers

LIVES:		.space 2   ; broj zivota, 0...99
WHITELIVES:		.space 2   ; brojac vremena prikazivanja belih zivota 100...0
BLUELIVES:		.space 2   ; brojac vremena prikazivanja plavih zivota 100...0
LEVEL:		.space 2   ; nivo igre, 0...12 (prikazuje se kao 1...13)
LEVELPRETH:	.space 2   ; prethodni nivo igre (pre adjust screen), 0...12
ADJROW:		.space 2   ; red koji se trenutno podesava, 0...3
MAXLEVEL:	.space 2   ; maksimalni level do koga je igrac posteno stigao
STARTLEVEL:	.space 2   ; nivo igre od koga je igra zapoceta

; buffers
SPRITELIST:	.space 20*12 ; +0: Xpos, +2: Ypos, +4: sirina sprajta, +6: visina sprajta, +8: offset, +10: page
COPYLIST:	.space 20*8  ; +0: sprite adr in rom, +2: sprite page in rom, +4: sprite buffer dst addr, +6: width/4
BOTTOMTXT:	.space 39*2	; bottom txt, lo by:ASCII char, hi by:(hi nib) bkgnd color, (lo nib) char color

FIELD:		.space 2	; zajedno sa sb1,sb2 treba 64*10=640 by za chargen	/vezano\
DUMMYSPACE1:	.space 86	;							|vezano|
SPRITEBUF1:		.space 190 	; 380/2  sprite buffer for lines 0, 2, 4, ...188        |vezano|
DUMMYSPACE2:	.space 86	;							|vezano|
SPRITEBUF2:		.space 190 	; 380/2  sprite buffer for lines 1, 3, 5, ...189        |vezano|
DUMMYSPACE3:	.space 86	;							\vezano/

; cloud pointers
ADRPIXELS:	.space 128	; adrese U MEMORIJI obojenih piksela
COLPIXELS:	.space 32	; boje obojenih piksela (po 2 pix u jednom bajtu: #0246 i #1357)
CLOUDX:		.space 2	; leva X pos crnog oblaka
CLOUDY:		.space 2	; gornja Y pos na kojoj ce se javljati sareni pikseli crnog oblaka
CLOUDTARGETX:	.space 2	; zadato CLOUDX
CLOUDTARGETY:	.space 2	; zadato CLOUDY
DUMMY:		.space 2	; dummy mesta, za nepotreban upis
CONV:		.space 12	; izlaz bin-dec konverzije (ascii)

; system
STACK_START:	.space 128
STACK_END:	.space 0
SPARE:		.space 40	; ZA DEBUG SAMO

BKGND:	.space	0  ; mora da bude ispod 7646, space 240x380/2=45600, do 53248 ostaju jos 2 dummy by
; </editor-fold>
.text
; <editor-fold desc="INITIALIZATION">
;
;  IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII  
;  IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII  
;  IIIIII																						   IIIIII
;  IIIIII																							IIIIII
;  IIIIII				I N I C I J A L I Z A C I J A											   IIIIII
;  IIIIII																								IIIIII
;  IIIIII																						   IIIIII
;  IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII  
;  IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII  
;

.global __reset
__reset:
	mov	#STACK_START,w15
	mov	#STACK_END,w0
	mov	w0,SPLIM 		; Stack Pointer Limit
;   					
;					; --- OSCILATOR -----------------------
;   					
	mov	#0b0000000000000000,w0
	mov	w0,CLKDIV
	mov	#144-2,w0		; 72 MIPS
	mov	w0,PLLFBD
;   					
;					; --- REMAPABLE PINS ------------------
;   					

	mov	#0b00010000,w0		; OC1 (hor sync)
	mov	#horport,w3
	mov.b	w0,[w3]
	mov	#0b00010001,w1		; OC2
	mov	#mus1port,w3
	mov.b	w1,[w3]
	mov	#0b00010010,w1		; OC3
	mov	#mus2port,w3
	mov.b	w1,[w3]
	mov	#0b00010011,w1		; OC4
	mov	#mus3port,w3
	mov.b	w1,[w3]
	mov	#0b00000001,w1		; U1TX
	mov	#jackport,w3
	mov.b	w1,[w3]
	mov	#0b00000011,w1		; U2TX
	mov	#effport,w3
	mov.b	w1,[w3]

;   					
;					; --- OUTPUT COMPARE, TIMERS AND INTERRUPT (SYNC) ------------------
;		 HOR SYNC (OC1, T1)	
	mov	#0b0000000000000000,w0	; no prescaler
	mov	w0,T1CON		; T1 for OC2 (HOR sync)
	clr	TMR1

	mov	#2048-HORSYNC-144,w0	; CP value for HOR sync start
	mov	w0,OC1R
	mov	#2048-HORSYNC,w0	; CP value for HOR sync end
	mov	w0,OC1RS
	mov	#2048-1,w0		; horizontal timing
	mov	w0,PR1
	mov	w0,OC1TMR
	mov	#0b0011000000001111,w0	; 111 = Center-Aligned PWM mode, timer 1 (HOR sync)
	mov	w0,OC1CON1
	mov	#0b0001000010001011,w0	; no fault handling, sync timer 1 (HOR sync)
	mov	w0,OC1CON2

;		 VERT SYNC (T2 INTERRUPT)
	mov	#0b0000000000100000,w0	; prescaler 1:64
	mov	w0,T2CON		; T2 interrupt for VERT sync
	mov	#20000-1,w0		; vertical timing
	mov	w0,PR2
	clr	TMR2

	mov	#0b1000000000000000,w0	; interrupt nesting disabled
	mov	w0,INTCON1
	mov	#0b0100000000000000,w0	; all interrupts disabled, DISI enabled
	mov	w0,INTCON2
;	
	bset	T1CON,#TON
	bset	T2CON,#TON
;   					
;					; --- OUTPUT COMPARE AND TIMERS (SOUND) ------------------
;		 CH 1 (T3, OC2)		
	mov	#0b0000000000100000,w0	; prescaler 1:64
	mov	w0,T3CON		; T3 sound OC2 timebase
	mov	#10227-1,w0
	mov	w0,PR3

	mov	#0b0010010000001111,w0	; 011 = Single compare toggle mode, timer 3
	mov	w0,OC2CON1
	mov	#0b0001000010001101,w0	; no fault handling, timer 3
	mov	w0,OC2CON2
	mov	#1,w0
	mov	w0,OC2R			; __/^^
	mov	w0,OC2RS		; ^^\__

;		 CH 2 (T4, OC3)		
	mov	#0b0000000000100000,w0	; prescaler 1:64
	mov	w0,T4CON		; T4 sound OC3 timebase
	mov	#9653-1,w0
	mov	w0,PR4

	mov	#0b0010100000001111,w0	; 011 = Single compare toggle mode, timer 4
	mov	w0,OC3CON1
	mov	#0b0001000010001110,w0	; no fault handling, timer 4
	mov	w0,OC3CON2
	mov	#1,w0
	mov	w0,OC3R			; __/^^
	mov	w0,OC3RS		; ^^\__

;		 CH 3 (T5, OC4)		
	mov	#0b0000000000100000,w0	; prescaler 1:64
	mov	w0,T5CON		; T5 sound OC4 timebase
	mov	#9112-1,w0
	mov	w0,PR5

	mov	#0b0010110000001111,w0	; 011 = Single compare toggle mode, timer 5
	mov	w0,OC4CON1
	mov	#0b0001000010001111,w0	; no fault handling, timer 5
	mov	w0,OC4CON2
	mov	#1,w0
	mov	w0,OC4R			; __/^^
	mov	w0,OC4RS		; ^^\__
;	
	clr	OC2TMR
	clr	OC3TMR
	clr	OC4TMR

;   					
;					 --- UART1 AND UART 2 (SOUND EFFECTS) ---------------------------
;   					

	mov	#0b0000000000000000,w0	; BRGH=0 (16 clk/period), UART disabled, RTS/CTS disabled
	mov	w0,U1MODE
	mov	#0b0100000000000000,w0	; TX out inverted (idle=0)
	mov	w0,U1STA
	bset	U1MODE,#15		; enable UART 1
	bset	U1STA,#UTXEN		; enable TX 1 (must be after UART enable)

	mov	#0b0000000000000000,w0	; BRGH=0 (16 clk/period), UART disabled, RTS/CTS disabled
	mov	w0,U2MODE
	mov	#0b0100000000000000,w0	; TX out inverted (idle=0)
	mov	w0,U2STA
	bset	U2MODE,#15		; enable UART 2
	bset	U2STA,#UTXEN		; enable TX 2 (must be after UART enable)

;   					
;					 --- PORTS ---------------------------
;   					

   .if	pcbver == 1			; ver 1
	clr	LATA
	clr	LATB
	clr	ANSELA
	clr	ANSELB

	mov	#0b0000000000000000,w0
	mov	w0,ODCA
	mov	#0b0000000010010000,w0
	mov	w0,ODCB

	mov	#0b01111,w0
	mov	w0,TRISA
	mov	#0b1010001000000100,w0
	mov	w0,TRISB

	mov	#0b00011,w0			; pull-up 
	mov	w0,CNPUA
	mov	#0b1010001000000100,w0		; pull-up
	mov	w0,CNPUB
   .endif
;
   .if	pcbver == 2			; ver 2
	clr	LATA
	clr	LATB
	clr	ANSELA
	clr	ANSELB

	mov	#0b0000000000000000,w0
	mov	w0,ODCA
	mov	#0b0000001000010000,w0
	mov	w0,ODCB

	mov	#0b01111,w0
	mov	w0,TRISA
	mov	#0b1010000000100100,w0
	mov	w0,TRISB

	mov	#0b00011,w0			; pull-up
	mov	w0,CNPUA
	mov	#0b1010000000100100,w0		; pull-up
	mov	w0,CNPUB
   .endif
;
   .if	pcbver == 3			; ver 3
	clr	LATA
	clr	LATB
	clr	ANSELA
	clr	ANSELB

	mov	#0b0000000000000000,w0
	mov	w0,ODCA
	mov	#0b0000100000010000,w0
	mov	w0,ODCB

	mov	#0b01111,w0
	mov	w0,TRISA
	mov	#0b1010001000000100,w0
	mov	w0,TRISB

	mov	#0b00011,w0			; pull-up
	mov	w0,CNPUA
	mov	#0b1010001000000100,w0		; pull-up
	mov	w0,CNPUB
   .endif
;
	bclr	RCON,#SWDTEN		; disable WDT ??

; </editor-fold>
; <editor-fold desc="startup">
;------------------------------------------ brisanje RAMa

	mov	#0,w0
	mov	w0,MUSIC		; default muzika: 0 = jumping jack flash, 1 = golden brown
	mov	#2,w0
	mov	w0,MUSICSOUNDS		; default music = High
	mov	#2,w0
	mov	w0,JACKSSOUNDS		; default jack's sounds = High
	mov	w0,OTHERSOUNDS		; default other sounds = High
	mov	#0,w0
	mov	w0,ROTATEJOY		; default rotate joystick: 0 = No, 1 = Yes
	mov	w0,ROTATEFINAL		; default rotate joystick: 0 = No, 1 = Yes

	mov	#CSCLR,w1		; start of GP ram
	bra	contstart
warmstart:
	mov	#WSCLR,w1		; at warm start (after game over) some ram area is kept unerased
contstart:
	mov	#BKGND,w2
2:
	add	w0,[w1],w0
	clr	[w1++]			; brise RAM od pocetka do BKGND
	cp	w1,w2
	bra	nc,2b
	mov.b	WREG,SEED		; randomize checksum
	swap	w0
	mov.b	WREG,SEED+2		; randomize checksum

	mov	#STACK_START,w15
	mov	#STACK_END,w0
	mov	w0,SPLIM 		; Stack Pointer Limit
;	
	mov	#380,w0
	mov	#SPRITELIST,w1
	mov	#20,w2
2:
	mov	w0,[w1]			; ponistava sve sprajtove (upisuje Xpos=380) u SPRITELIST
	add	#12,w1
	dec	w2,w2
	bra	nz,2b
					; Jack zauzima 18. sprajt (SPRITELIST+17*12)
;	
	inc	MAXLEVEL		; =1

	mov	#RUPE,w3
.rept 8
	mov	#170,w1
	call	rndrange
	mov	w0,[w3++]
	mov	#6,w1
	call	rndrange
	mov	w0,[w3++]
.endr
	call	inibottomline

	mov	#6*34,w0
	mov	w0,LIFT1TARGET
	mov	#6*34,w0
	mov	w0,LIFT2TARGET
	call	drawlift1
	call	drawlift2
	call	mixer		; podesava jacine zvukova

	mov	#156,w0
	mov	w0,JACKX
	mov	#210,w0
	mov	w0,JACKY
	mov	w0,REALY

	mov	#30,w0
	mov	w0,CEKALICA	; da pola sekunde ignorise tastere A i B

	mov	#190,w0
	mov	w0,CLOUDX
	mov	w0,CLOUDTARGETX

	mov	#-40,w0
	mov	w0,UFOY
	mov	#999,w0
	mov	w0,UFOX		; da bude van X opsega

;	
	bset	IEC0,#T2IE		; enable Timer 2 interrupts (vert sync)
	bset	INTCON2,#GIE		; all interrupts enabled
; </editor-fold>
; <editor-fold desc="post startup and restart EPTs">
	call	calcstop	; odredjuje broj znakova prema LEVEL i eventualno dopunjava tabelu STOPX, STOPY
	mov	#5,w0
	mov	w0,LIVES
	call	printlives
	bra	startlev
pause:
	goto	splash		; adjust screen
newlevel:		;	 next level									
	inc	LEVEL		; LEVEL +
	mov	LEVEL,w0
	inc	w0,w0
	cp0	STARTLEVEL
	ifz			; ako je igrac posteno stigao do novog nivoa...
	mov	w0,MAXLEVEL	; prethodni+1 se upisuje u maxlevel
startlev:
	call	clr.effects
	call	drawbkgnd
	call	startedfromlevel ; ako je STARTLEVEL>0 ispisuje poruku u donjem redu, inace brise donji red
	mov	LEVEL,w0
	cp	w0,#13
	bra	c,gotovaigra
	mov	#94,w0		; 1,7 sec
	mov	w0,SHOWLEVELCOUNT
	call	drawstops	; crta sve znakove

; ispisuje poruku LEVEL... na podlozi

	mov	#120,w4		; X pos podloge natpisa "LEVEL  "
	mov	#96,w5		; Y pos podloge natpisa "LEVEL  "
	mov	#140,w6		; sirina
	mov	#49,w7		; visina
	mov	#0b0000001100000011,w3	; tamno crveno
	call	podloga		; podloga za "LEVEL  "

	mov	#0b11001111,w0	; ink zut
	mov	w0,INK
	asciiprint	156,115,levelpor	; ispisuje poruku  "LEVEL"  na sredini podloge

	mov	#BKGND+216/2+115*190,w4	; wr ptr u video mem
	mov	LEVEL,w0
	inc	w0,w0
	call	bdconv2		; w0 konvertuje u desetice (conv+8) i jedinice (conv+10)

	mov	CONV+8,w2	; desetice
	cp	w2,#'0'
	bra	z,2f
	sub	#4,w4		; ako je dvocifren, onda malo levo
	call	printchar	; print char w2 u video mem, wr ptr [w4]
2:
	mov	CONV+10,w2	; jedinice
	call	printchar	; print char w2 u video mem, wr ptr [w4]
startlev.mali:
	call	printlev	; prints level number in the bottom line
;	
	bra	farm0
; </editor-fold>
; <editor-fold desc="cont restart EPTs">
congrat:
	.asciz	"CONGRATULATIONS"
youwin:
	.asciz	"YOU WIN"
pressany:
	.asciz	"PRESS ANY KEY"

gotovaigra:
	call	drawbkgnd	; da bi izbrisao stopove

	mov	#80,w4		; X pos podloge natpisa "CONGRATULATIONS YOU WIN"
	mov	#96-34,w5	; Y pos podloge natpisa "CONGRATULATIONS YOU WIN"
	mov	#220,w6		; sirina
	mov	#117,w7		; visina 2 sprata
	mov	#0b0000001100000011,w3	; tamno crveno
	call	podloga		; podloga

	call	clr.all.sounds

	mov	#0b11111111,w0	; ink wh
	mov	w0,INK
	asciiprint	115,115-34,congrat	; ispisuje poruku  "CONGRATULATIONS"  na sredini podloge
	mov	#0b11001111,w0	; ink ly
	mov	w0,INK
	asciiprint	155,115,youwin		; ispisuje poruku  "YOU WIN"  na sredini podloge
	mov	#0b11111100,w0	; ink lc
	mov	w0,INK
	asciiprint	126,115+34,pressany	; ispisuje poruku  "PRESS ANY KEY"  na sredini podloge
;	mov	#30,w0
;	mov	w0,CEKALICA	; da pola sekunde ignorise tastere

	mov	#KEYROTORS,w3
	repeat	#6-1
	clr	[w3++]		; debouncer reset

	bset	F2,#7		; #7 = set ako je congratulations
; </editor-fold>
; <editor-fold desc="FARM">

farm0:
	mov	LEVEL,w4
	mulw.uu	w4,#7,w4	; x 7
	movpag	#tblpage(raterupe),TBLPAG
	mov	#tbloffset(raterupe),w2
	add	w2,w4,w2
	clr	w0
	tblrdl.b [w2++],w0
	mov	w0,RATE			; verovatnoca pojavljivanja horizontalnog akrepa, 1=na 1s, 2=na 2s, itd
	tblrdl.b [w2++],w0
	mov	w0,VERTRATE		; verovatnoca pojavljivanja vertikalnog akrepa, 1=na 1s, 2=na 2s, itd
	tblrdl.b [w2++],w0
	mov	w0,CUBERATE		; verovatnoca pojavljivanja kocke, 1=na 1s, 2=na 2s, itd
	tblrdl.b [w2++],w0
	mov	w0,SHIELDRATE	; verovatnoca pojavljivanja shielda, 1=na 1s, 2=na 2s, itd
	tblrdl.b [w2++],w0
	mov	w0,BROJRUPA		; broj rupa
	tblrdl.b [w2++],w0
	mov	w0,STEADY		; koliko dugo ceka shield posle spustanja
	tblrdl.b [w2++],w0
	mov	w0,SHIELDTIME	; koliko dugo nosi shield

;  FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
;  FFFFFF											   FFFFFF
;  FFFFFF					F  A  R  M				   FFFFFF
;  FFFFFF											   FFFFFF
;  FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF

farm:

 
; /\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\
;			 	 izmedju dva frejma ostaje slobodno 230K T					
; /\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\

;	bclr	FLAG,#7		; bezuslovno gasi flag za pad (za probu)     ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	call	rnd.addr
	btsc	F2,#3		; #3 = set ako postoji oblak
	call	exch.pixels	; postavi nove sarene piksele
6:
	sync	;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX   MAIN  SYNC   XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

	btsc	F2,#3		; #3 = set ako postoji oblak
	call	exch.pixels	; vrati stare piksele u pozadinu

	call	sounds
	call	move.holes
	call	lines
	call	elevators
;	
	btss	FLAG,#12	; set ako je upaljeno svetlo u levom
	bra	2f
	btsc	FLAG,#13	; set ako je upaljeno svetlo u desnom
	bclr	FLAG,#7		; nasilno gasi flag za pad ako su oba svetla upaljena
2:
	mov	JACKY,w0
	cp	w0,#220-30
	bra	nc,3f

	btss	FLAG,#12	; set ako je upaljeno svetlo u levom
	bra	3f
	btsc	FLAG,#13	; set ako je upaljeno svetlo u desnom
	btsc	F2,#7		; bit 7 = set ako je congratulations
	bra	3f		; ne gasi liftove ako je congratulations
				; ovde je na donjem spratu i oba svetla su upaljena - gasi ih (novi nivo)
	bclr	FLAG,#12
	bclr	FLAG,#13

;		
	mov	#6*34,w0
	btsc	JACKX,#8
	mov	w0,LIFT1TARGET	; home lift 1
	btss	JACKX,#8
	mov	w0,LIFT2TARGET	; home lift 2
;
	call	drawlift1
	call	drawlift2
3:
;						
					; racuna tacan REALY
	clr	w3

	mov	PLAYPTRJUMP,w0
	sl	w0,#2,w0		; *4, jer jedan clan tabele ima 4 by
	bra	z,1f
	movpag	#tblpage(jumpseq),TBLPAG
	mov	#tbloffset(jumpseq)+2,w1
	add	w0,w1,w0
	tblrdl	[w0],w3		; tu je Y offset
	mov	JACKY,w0
	sub	w0,w3,w0
	mov	w0,REALY
	bra	exitoffs
1:
	mov	PLAYPTRFALL,w0
	sl	w0,#2,w0		; *4, jer jedan clan tabele ima 4 by
	bra	z,1f
	movpag	#tblpage(fallseq),TBLPAG
	mov	#tbloffset(fallseq)+2,w1
	add	w0,w1,w0
	tblrdl	[w0],w3		; tu je Y offset
	mov	JACKY,w0
	add	w0,w3,w0
	mov	w0,REALY
	bra	exitoffs
1:
	mov	PLAYPTRDOWN,w0
	sl	w0,#2,w0		; *4, jer jedan clan tabele ima 4 by
	bra	z,exitoffs
	movpag	#tblpage(downseq),TBLPAG
	mov	#tbloffset(downseq)+2,w1
	add	w0,w1,w0
	tblrdl	[w0],w3		; tu je Y offset
	mov	JACKY,w0
	add	w0,w3,w0
	mov	w0,REALY
exitoffs:


; </editor-fold>
; <editor-fold desc="message and music manager">
;												
;				message and music manager					
;_______________________________________________________________________________________________

;	countdown i vracanje slike na svoje mesto umesto podloge
	cp0	SHOWLEVELCOUNT
	bra	z,1f
	dec	SHOWLEVELCOUNT	; decif
	bra	nz,1f

;	btsc	F2,#7		; #7 = set ako je congratulations
;	bra	1f		; nista ne brise ako je game over

	mov	#120,w4		; X pos podloge natpisa "LEVEL  "
	mov	#96,w5		; Y pos podloge natpisa "LEVEL  "
	mov	#140,w6		; sirina
	mov	#49,w7		; visina
	call	restore		; vraca sliku na svoje mesto umesto podloge
	call	startedfromlevel	; brise donji red ako je igra postena, inace poruka Started From...
1:
;		

	cp0	WHITELIVES	; brojac vremena prikazivanja belih zivota 100...0
	bra	z,4f
	dec	WHITELIVES
	bra	z,redlives	; just reached 0
	mov	#0b01010101,w0	; white
	bra	w0bl
4:
	cp0	BLUELIVES	; brojac vremena prikazivanja plavih zivota 100...0
	bra	z,3f
	dec	BLUELIVES
	bra	z,redlives	; just reached 0
	mov	#0b01010000,w0	; light blue
	bra	w0bl
redlives:			; just reached 0
	mov	#0b01000001,w0	; light red
w0bl:
	mov.b	WREG,BOTTOMTXT+1
	mov.b	WREG,BOTTOMTXT+3
	mov.b	WREG,BOTTOMTXT+5
	mov.b	WREG,BOTTOMTXT+7
	mov.b	WREG,BOTTOMTXT+9
3:
;	 music			
	mov	MUSICPAGE,w0
	ior	MUSICPTR,WREG
	cp0	w0
	bra	nz,3f		; jer je muzika u toku

	mov	MUSIC,w0
	cp	w0,#0
	bra	nz,2f
	mov	#tblpage(jagger),w1
	mov	w1,MUSICPAGE
	mov	#tbloffset(jagger),w1
	mov	w1,MUSICPTR
2:
	cp	w0,#1
	bra	nz,2f
	mov	#tblpage(brown),w1
	mov	w1,MUSICPAGE
	mov	#tbloffset(brown),w1
	mov	w1,MUSICPTR
2:
	cp	w0,#2
	bra	nz,3f
	mov	#tblpage(xxxxx),w1
	mov	w1,MUSICPAGE
	mov	#tbloffset(xxxxx),w1
	mov	w1,MUSICPTR
3:
; </editor-fold>
; <editor-fold desc="cloud">
;												
;				cloud								
;_______________________________________________________________________________________________

	bset	F2,#3		; #3 = set ako postoji oblak

;	odlucuje da li ce pomerati oblak
	cp0	LIVES
	bra	z,nocloudmove	; da ne kvari pozvan oblak na kraju igre

	mov	VGAUNIFORM,w1
	and	#63,w1
	bra	nz,nocloudmove
	mov	#8,w1		; verovatnoca pojavljivanja, 1=na 1s, 2=na 2s, itd
	call	rndrange
	cp0	w0
	bra	nz,nocloudmove
				; cloud target move
	mov	JACKX,w0
	sub	#24,w0		; toliko je od sredine jacka do sredine clouda
	btsc	w0,#15
	clr	w0		; if negative than 0
	cp	w0,#24		; tako ce cloudx biti u opsegu 24-294 (sirina je 62, dakle desna ivica ide do 356)
	manji
	mov	#24,w0
	mov	#294,w1
	cp	w0,w1		; tako ce cloudx biti u opsegu 24-294 (sirina je 62, dakle desna ivica ide do 356)
	istiveci
	mov	#294,w0
	mov	w0,CLOUDTARGETX

	mov	JACKY,w0
	sub	#4,w0
	mov	w0,CLOUDTARGETY
nocloudmove:
;	pomera oblak ako je CLOUDTARGETX <> CLOUDX

	mov	VGAUNIFORM,w0
	and	#7,w0		; horizontalna brzina priblizavanja oblaka
	bra	nz,nisurazliciti

	mov	CLOUDTARGETX,w0
	sub	CLOUDX,WREG	; cloudx - cloudtargetx, NC ako je cloudx < cloudtargetx
	bra	z,nisurazliciti

	bra	nc,oblak.nadesno
	dec	CLOUDX		; oblak nalevo
	bra	nisurazliciti
oblak.nadesno:
	inc	CLOUDX		; oblak nadesno
nisurazliciti:
;	podesava cloudy
	mov	VGAUNIFORM,w0
	and	#7,w0		; vertikalna brzina priblizavanja oblaka
	bra	nz,noadjcl

	mov	CLOUDY,w0
	cp	CLOUDTARGETY	; cloudtargety - w0, NC ako je cloudtergety < w0
	ifc
	inc2	CLOUDY
	dec	CLOUDY		; ako je bio NC, ostace inc, a ako je C onda ce ostati dec (polako se piblizava)
noadjcl:
	mov	CLOUDY,w0
	btsc	w0,#15
	clr	w0
	mov	#215-32,w1
	cp	w0,w1
	istiveci
	mov	#215-32,w0

;	usporava jacka ako je u oblaku
	btss	F2,#3		; #3 = set ako postoji oblak
	bra	notincl
			; prvo Y match
	mov	CLOUDY,w0
	add	#5,w0		; jer je jacky za 5 pix nizi od clouda
	sub	JACKY,WREG
	btsc	w0,#15
	neg	w0,w0
	cp	w0,#10
	bra	c,notincl	; ne usporava ga ako je Y razlika veca od 10
			; sledi X match
	mov	JACKX,w0
	add	#10,w0		; jer je tu centar jacka
	subr	CLOUDX,WREG
	bra	nc,notincl	; jer je jack levo od oblaka
	cp	w0,#62		; to je sirina clouda
	bra	c,notincl
	bset	F2,#4		; F2,#4 = set ako je jack u oblaku
;	
	cp0	VGAUNIFORM
	bra	nz,1f
	call	rnd
	and	#7,w0
	bra	nz,1f
1:
;	
	bra	exitcl
notincl:
	bclr	F2,#4		; F2,#4 = set ako je jack u oblaku
exitcl:
; </editor-fold>
; <editor-fold desc="elevator autostart patience service">
;												
;			elevator autostart patience service					
;_______________________________________________________________________________________________

	btss	FLAG,#10	; FLAG,#10 = jack u liftu
	bra	notinlift

	dec.b	LIFTPATIENCE	; patience = 256 frames
	bra	nz,nyet0
;	    just 0
	mov	#34,w0		; za brzi silazak ako su oba svetla upaljena
	btss	FLAG,#12	; set ako je upaljeno svetlo u levom
	bra	nolight
	btsc	FLAG,#13	; set ako je upaljeno svetlo u desnom
	mov	w0,LIFTPATIENCE	; brzi silazak ako su oba svetla upaljena
nolight:
	mov	#LIFT1TARGET,w3
	mov	JACKX,w0
	cp	w0,#380/2
	istiveci
	mov	#LIFT2TARGET,w3
	mov	[w3],w0
	cp	w0,#5*34+1
	istiveci
	bra	nyet0		; jer je vec na donjem nivou pa ne moze da ide nize
	add	#34,w0
	mov	w0,[w3]		; novi target za sprat nizi
	bset	FLAG,#11	; FLAG,#11 = da Jack treba da prati lift dok se spusta

	btss	FLAG,#12	; set ako je upaljeno svetlo u levom (da ne svira ako su oba)
	bra	1f
	btsc	FLAG,#13	; set ako je upaljeno svetlo u desnom (da ne svira ako su oba)
	bra	fanfare
1:
	tirli1	liftdown
	bra	nyet0
fanfare:
	btsc	F2,#6		; #6 = set ako su vec bile fanfare
	bra	nyet0
	bset	F2,#6		; #6 = set ako su vec bile fanfare
	tirli1	spec		; ovo treba da bude svecana muzika jer je osvojio novi nivo
	bra	nyet0
notinlift:
	bclr	FLAG,#11	; FLAG,#11 = da Jack treba da prati lift dok se spusta
	clr	LIFTPATIENCE
nyet0:
; </editor-fold>
; <editor-fold desc="limit Jack's Y position">
;												
;			limitira Y polozaj za Jacka						
;_______________________________________________________________________________________________

	mov	#0xd3,w1
	mov	JACKY,w0
	cp	w0,w1
	ifc
	mov	w1,JACKY

	mov	#6,w1
	mov	JACKY,w0
	cp	w0,w1
	ifnc
	mov	w1,JACKY	; sada je jacky u opsegu 6...0xd3

;			sad jos samo da zaokruzi Y na frakciju 34

	btsc	FLAG,#10	; FLAG,#10 = jack u liftu
	bra	2f		; ne zaokruzuje ako je u liftu

	mov	JACKY,w0
	mov	#8,w1
.rept 6
	cp	w0,w1
	bra	nc,1f		; ako je manji od 8,42,76,110,144,178...
	add	#34,w1
.endr
1:
	dec2	w1,w1		; ...onda 6,40,75,108,142,176, ako nista od toga onda 210
	mov	w1,JACKY	; fiksiran na tacan sprat

	mov	#0xd3,w1
	mov	JACKY,w0
	cp	w0,w1
	ifc
	mov	w1,JACKY
2:
; </editor-fold>
; <editor-fold desc="randomizuje zaustavljanje rupa">
;												
;			randomizuje zaustavljanje rupa						
;_______________________________________________________________________________________________

	call	rnd
	mov	SEED+0,w0
	and	#0xfe,w0
	bra	nz,not5s
	mov	SEED+2,w0
	and	#0xf,w0
	btsc	w0,#3
	clr	w0		; if >8 than =0
	mov	w0,RUPASTOP	; ova rupa miruje (0=nijedna)
not5s:
; </editor-fold>
; <editor-fold desc="key service">
;												
;			key service    **********************************************		
;_______________________________________________________________________________________________


	btsc	F2,#9		; bit 9 = set ako je vec detektovao bar jedan edge na kbd
	bra	1f
	call	getedge		; ovo ce zvati samo jednom
	ifnz
	bset	F2,#9		; bit 9 = set ako je vec detektovao bar jedan edge na kbd
1:
	cp0	CEKALICA
	bra	z,contkey
	dec	CEKALICA
contkey:
	btss	F2,#7		; bit 7 = set ako je congratulations
	btsc	F2,#8		; bit 8 = set ako je game over (0 lives)
	bra	oneset
	bra	obaclr
oneset:
	call	getedge
	bra	nz,warmstart	; soft reset
obaclr:
	call	getkey
	btss	FLAG,#12	; set ako je upaljeno svetlo u levom
	bra	nolight2
	btsc	FLAG,#13	; set ako je upaljeno svetlo u desnom
	and	#0b00100000,w0	; ignorise tastere (osim B) ako su oba svetla upaljena
nolight2:
	btsc	FLAG,#10	; bit 10 = set ako je jack u liftu (bilo kom)
	and	#0b00100011,w0	; ignorise tastere A, DOWN i UP ako je jack u liftu (moze levo, desno i pauza)

	cp0	CEKALICA
	ifnz
	and	#0b11001111,w0	; ignorise taster A i B ako je na cekalici

	btsc	w0,#5		; B = pauza
	bra	pause

	mov	w0,JACKMOVE
	call	movejack	; svi Jackovi pokreti su ovde
;	
	mov	#210,w0
	subr	REALY,WREG
	add	#8,w0
	mov	#34,w2
	repeat	#17
	div.u	w0,w2
	mov	w0,JACKFLOOR	; na tom spratu je fizicki jack
; </editor-fold>
; <editor-fold desc="spiderman incif / decif">
;												
;			spiderman incif/decif					
;_______________________________________________________________________________________________

	cp0	PLAYPTRFALL
	bra	nz,floor6		; no spiderman jer je pad u toku

	mov	JACKFLOOR,w0
	cp		w0,#6
	bra		z,floor6		; na 6. spratu nema spiderman
;	cp0		w0
;	bra		z,floor6		; na 0. spratu nema spiderman
	mov	JACKX,w0
	cp	w0,#16
	bra	nc,floor6				; manji od 16 = u levom liftu
	mov	#354,w1
	cp	w0,w1
	bra	c,floor6				; veci od 354 = u desnom liftu

	btss	JACKMOVE,#2
	bra		otpup
							; ovde je UP pritisnut
	mov		SPIDERCOUNT,w0
	cp		w0,#11
	manji
	inc	SPIDERCOUNT

	cp	w0,#8
	bra	nz,anyup
	tirli1	spiderup
	bra	anyup
floor6:
		clr		SPIDERCOUNT
		bra		anyup
otpup:
							; ovde je UP otpusten
	cp0		SPIDERCOUNT
	ifnz
	dec	SPIDERCOUNT

	mov	SPIDERCOUNT,w0
	cp	w0,#3
	bra	nz,anyup
	tirli1	spiderdown
	bra	anyup
anyup:
; </editor-fold>
; <editor-fold desc="ufo shield">

;												
;			ufo shield								
;_______________________________________________________________________________________________
	btsc	FLAG,#14	; FLAG,#14 = ufo in the game
	bra	ufoinside

	clr	UFOSTEADY

	mov	VGAUNIFORM,w1
	and	#63,w1
	bra	nz,ufoexit
	mov	SHIELDRATE,w1		; verovatnoca pojavljivanja, 1=na 1s, 2=na 2s, itd
	call	rndrange
	cp0	w0
	bra	nz,ufoexit
				; 1/4096 possibility, avg once in 73 secs
	bset	FLAG,#14	; FLAG,#14 = ufo inside
	mov	#4,w1		; na izlazu iz rndrange bice 0...3
	call	rndrange
	add	#2,w0		; 2...5
	mov	#34,w1		; da pada do 5...2 sprata
	mulw.uu	w0,w1,w0
	sub	#27,w0
	mov	w0,UFOVANISH	; dotle ce da pada

	call	rnd
	add	#62-6,w0
	mov	w0,UFOX		; 62-6...318-6
	bra	ufoexit
ufoinside:			; ufo je vec unutra
	cp0	UFOTIMER
	bra	z,nodecif
	dec	UFOTIMER	; decif
	bra	z,vanish	; ufotimer just reached zero
nodecif:
	inc	UFOCOUNT	; ufocount je za animaciju ufo-a
	mov	UFOCOUNT,w0
	cp	w0,#12
	istiveci
	clr	w0		; ufocount je u opsegu 0...11
	mov	w0,UFOCOUNT
		
	btsc	FLAG,#15	; FLAG,#15 = shield
	bra	follow
				; ufo je unutra, ali ga jack jos nije uhvatio
	mov	VGAUNIFORM,w0
	and	#3,w0
	ifz			; ovo usporava padanje ufo
	inc	UFOY
	mov	UFOVANISH,WREG
	btsc	UFOY,#15
	bra	novanish	; jer jos nije ni presao Y nulu
	cp	UFOY		; ufoy - ufovanish, C set if ufoy is on vanish level
	ifc
	inc	UFOSTEADY
	cp	UFOY		; ufoy - ufovanish
	ifc
	dec	UFOY		; anulira uvecanje, da bi mirovao na ufovanish
	mov	STEADY,w1
	mov	UFOSTEADY,w0
	cp	w0,w1		; koliko dugo te ceka ufo
	bra	nc,novanish
vanish:
	clr	UFOSTEADY
	bclr	FLAG,#14	; FLAG,#14 = ufo inside
	bclr	FLAG,#15	; FLAG,#15 = shield
	mov	#-40,w0
	mov	w0,UFOY		; vanished
	mov	#999,w0
	mov	w0,UFOX		; da bude van X opsega, da rastereti vga rutinu
	bra	not.yet.catched
novanish:			; ufo je unutra, jack ga jos nije uhvatio i nije stigao do vanish visine
	mov	UFOY,w0
	sub	REALY,WREG
	btsc	w0,#15
	neg	w0,w0
	cp	w0,#16
	bra	c,not.yet.catched	; not just catched (Y mismatch)

	mov	UFOX,w0
	sub	JACKX,WREG
	btsc	w0,#15
	neg	w0,w0
	cp	w0,#20
	bra	c,not.yet.catched	; jer ga jos nije uhvatio, plovi nadole (X razlika veca od 26)
				;	 UPRAVO JE UHVATIO UFO
	tirli1	newlife
	mov	LIVES,w0
	cp	w0,#99
	manji
	inc	LIVES
	mov	#133,w0
	mov	w0,WHITELIVES
	call	printlives

	mov	SHIELDTIME,w0		; vreme nosenja stita je (SHIELDTIME/56)*8 sekundi
	sl	w0,#3,w0
	cp0	UFOTIMER
	ifz
	mov	w0,UFOTIMER
	bset	FLAG,#15		; FLAG,#15 = shield
	bra	ufoexit
follow:					; UFO prati jacka
	mov	JACKX,w0
	mov	w0,UFOX
	mov	REALY,w0
	mov	w0,UFOY
not.yet.catched:
	mov	UFOCOUNT,w0
	mov	#52*52/2,w1		; jedan sprite u bajtovima
	mulw.uu	w0,w1,w0	
	mov	#psvoffset(ufo1),w1
	add	w0,w1,w7

	mov	#SPRITELIST+0*12,w3	; UFO zauzima 1.sprajt

	mov	UFOX,w0
	sub	#20,w0
	mov	w0,[w3++]		; +0  X pos sprajta (od leve ivice)
	mov	UFOY,w0
	sub	#14,w0
	mov	w0,[w3++]		; +2  Y pos sprajta (od GORNJE ivice)

	mov	#52,w0
	mov	w0,[w3++]		; +4  sirina sprajta
	mov	#52,w0
	mov	w0,[w3++]		; +6  visina sprajta

	mov	w7,[w3++]		; +8  adresa sprajta u romu
	mov	#psvpage(ufo1),w0
	mov	w0,[w3++]		; +10  stranica
ufoexit:
; </editor-fold>
; <editor-fold desc="enemies">

;																		;
;			ostali likovi												;
;																		;

;__________________________NOGE LEFT_________________________________________________________________

	btsc	FA,#0			; bit 0 = set ako je akrep NOGEL u akciji
	bra	vecjeinl

	mov	VGAUNIFORM,w1
	and	#63,w1
	bra	nz,nogelexit
	mov	RATE,w1			; verovatnoca pojavljivanja, 1=na 1s, 2=na 2s, itd
	call	rndrange
	cp0	w0
	bra	nz,nogelexit
					; akrep NOGEL se inicijalizuje
	mov	#6,w1
	call	rndrange		; u w0 je sprat 0...5

	mov	#ZAUZETI,w1
	add	w0,w1,w1
	cp0.b	[w1]
	bra	nz,nogelexit		; jer je taj sprat vec zauzet
	setm.b	[w1]			; zauzima sprat
	mov	w1,NOGELSPRAT

	mov	#34,w1
	mulw.uu	w0,w1,w2
	add	#6,w2
	mov	w2,NOGELY

	mov	#380,w0
	mov	w0,NOGELX

	clr	NOGELCOUNT
	bset	FA,#0			; bit 0 = set ako je akrep NOGE u akciji
	bra	nogelexit
vecjeinl:			;
	inc.b	NOGELCOUNT
	bclr	NOGELCOUNT,#4		; limitira NOGELCOUNT na 0...15
	mov	#4,w0
	mov	NOGELCOUNT,w1
	cp	w1,#12
	ifz
	sub	NOGELX			; na 12. sprajtu se NOGELX umanjuje za 4 (takav je crtez)
	mov	#12,w0
	cp0	NOGELCOUNT
	ifz
	sub	NOGELX			; na 0. sprajtu se NOGELX umanjuje za jos 12 (novi step)

	cp0	NOGELCOUNT
	bra	nz,1f
	tirli2	noga
1:
	mov	#32,w0
	add	NOGELX,WREG
	btss	w0,#15
	bra	nonogelend
					; ovde su noge izasle iz ekrana (NOGELX < -32)
	bclr	FA,#0			; bit 0 = set ako je akrep NOGE u akciji
	mov	#-40,w0
	mov	w0,NOGELY		; vanished
	mov	#999,w0
	mov	w0,NOGELX		; da bude van X opsega, da rastereti vga rutinu

	mov	NOGELSPRAT,w1
	clr.b	[w1]
nonogelend:
	mov	NOGELCOUNT,w0
	mov	#32*27/2,w1		; jedan sprite u bajtovima
	mulw.uu	w0,w1,w0
	mov	#psvoffset(nogeleft),w1
	add	w0,w1,w7		; point na tekuci sprajt

	mov	#SPRITELIST+1*12,w3	; NOGEL zauzimaju 2.sprajt

	mov	NOGELX,w0
	mov	w0,[w3++]		; +0  X pos sprajta (od leve ivice)
	mov	NOGELY,w0
	mov	w0,[w3++]		; +2  Y pos sprajta (od GORNJE ivice)

	mov	#32,w0
	mov	w0,[w3++]		; +4  sirina sprajta
	mov	#27,w0
	mov	w0,[w3++]		; +6  visina sprajta

	mov	w7,[w3++]		; +8  adresa sprajta u romu
	mov	#psvpage(nogeleft),w0
	mov	w0,[w3++]		; +10  stranica

;				NOGE LEFT COLLISION TEST

	mov	JACKX,w0
	add	#10,w0			; jer je tu centar jacka
	mov	NOGELX,w1
	add	#16,w1			; jer je tu centar nogu
	sub	w0,w1,w0
	btsc	w0,#15
	neg	w0,w0
	cp	w0,#12
	bra	c,nogelexit

	mov	REALY,w0
	mov	NOGELY,w1
	sub	w0,w1,w0
	btsc	w0,#15
	neg	w0,w0
	cp	w0,#6
	bra	c,nogelexit

	mov	PLAYPTRDOWN,w0
	cp	w0,#25
	bra	c,nogelexit		; \	; jer je down pri kraju

	btss	FLAG,#15		; bit 15 = shield on
	bset	FLAG,#1		; FLAG,#1 = set if hit by enemy, clr if dropped thru hole
	btss	FLAG,#15		; bit 15 = shield on
	bset	FLAG,#7			; FLAG,#7 = FALL flag (sam ce se resetovati)
nogelexit:

;__________________________NOGE RIGHT_________________________________________________________________

	btsc	FA,#1			; bit 0 = set ako je akrep NOGER u akciji
	bra	vecjeinr

	mov	VGAUNIFORM,w1
	and	#63,w1
	bra	nz,nogerexit
	mov	RATE,w1			; verovatnoca pojavljivanja, 1=na 1s, 2=na 2s, itd
	call	rndrange
	cp0	w0
	bra	nz,nogerexit
					; akrep NOGER se inicijalizuje
	mov	#6,w1
	call	rndrange		; u w0 je sprat 0...5

	mov	#ZAUZETI,w1
	add	w0,w1,w1
	cp0.b	[w1]
	bra	nz,nogerexit		; jer je taj sprat vec zauzet
	setm.b	[w1]			; zauzima sprat
	mov	w1,NOGERSPRAT

	mov	#34,w1
	mulw.uu	w0,w1,w2
	add	#6,w2
	mov	w2,NOGERY

	mov	#-24,w0
	mov	w0,NOGERX

	clr	NOGERCOUNT
	bset	FA,#1			; bit 1 = set ako je akrep NOGEL u akciji
	bra	nogerexit
vecjeinr:			;
	inc.b	NOGERCOUNT
	bclr	NOGERCOUNT,#4		; limitira NOGERCOUNT na 0...15
	mov	#4,w0
	mov	NOGERCOUNT,w1
	cp	w1,#12
	ifz
	add	NOGERX			; na 12. sprajtu se NOGERX uvecava za 4 (takav je crtez)
	mov	#12,w0
	cp0	NOGERCOUNT
	ifz
	add	NOGERX			; na 0. sprajtu se NOGERX uvecava za jos 12 (novi step)

	cp0	NOGERCOUNT
	bra	nz,1f
	tirli2	noga
1:
	mov	NOGERX,w0
	mov	#384,w1
	cp	w0,w1
	bra	n,nonogerend
					; ovde su noge izasle iz ekrana (NOGERX < -32)
	bclr	FA,#1			; bit 1 = set ako je akrep NOGER u akciji
	mov	#-40,w0
	mov	w0,NOGERY		; vanished
	mov	#999,w0
	mov	w0,NOGERX		; da bude van X opsega, da rastereti vga rutinu

	mov	NOGERSPRAT,w1
	clr.b	[w1]
nonogerend:
	mov	NOGERCOUNT,w0
	mov	#32*27/2,w1		; jedan sprite u bajtovima
	mulw.uu	w0,w1,w0
	mov	#psvoffset(nogeright),w1
	add	w0,w1,w7		; point na tekuci sprajt

	mov	#SPRITELIST+2*12,w3	; NOGER zauzimaju 3.sprajt

	mov	NOGERX,w0
	mov	w0,[w3++]		; +0  X pos sprajta (od leve ivice)
	mov	NOGERY,w0
	mov	w0,[w3++]		; +2  Y pos sprajta (od GORNJE ivice)

	mov	#32,w0
	mov	w0,[w3++]		; +4  sirina sprajta
	mov	#27,w0
	mov	w0,[w3++]		; +6  visina sprajta

	mov	w7,[w3++]		; +8  adresa sprajta u romu
	mov	#psvpage(nogeright),w0
	mov	w0,[w3++]		; +10  stranica

;				NOGE RIGHT COLLISION TEST

	mov	JACKX,w0
	add	#10,w0			; jer je tu centar jacka
	mov	NOGERX,w1
	add	#16,w1			; jer je tu centar nogu
	sub	w0,w1,w0
	btsc	w0,#15
	neg	w0,w0
	cp	w0,#12
	bra	c,nogerexit

	mov	REALY,w0
	mov	NOGERY,w1
	sub	w0,w1,w0
	btsc	w0,#15
	neg	w0,w0
	cp	w0,#6
	bra	c,nogerexit

	mov	PLAYPTRDOWN,w0
	cp	w0,#25
	bra	c,nogerexit		; \	; jer je down pri kraju

	btss	FLAG,#15		; bit 15 = shield on
	bset	FLAG,#1		; FLAG,#1 = set if hit by enemy, clr if dropped thru hole
	btss	FLAG,#15		; bit 15 = shield on
	bset	FLAG,#7			; FLAG,#7 = FALL flag (sam ce se resetovati)
nogerexit:

;____________________________CATTERPILLAR LEFT_______________________________________________________

	btsc	FA,#2			; bit 2 = set ako je akrep CATTERPILLAR LEFT u akciji
	bra	vecjein.cl

	mov	VGAUNIFORM,w1
	and	#63,w1
	bra	nz,cplexit
	mov	RATE,w1			; verovatnoca pojavljivanja, 1=na 1s, 2=na 2s, itd
	call	rndrange
	cp0	w0
	bra	nz,cplexit
					; akrep se inicijalizuje
	mov	#6,w1
	call	rndrange		; u w0 je sprat 0...5

	mov	#ZAUZETI,w1
	add	w0,w1,w1
	cp0.b	[w1]
	bra	nz,cplexit		; jer je taj sprat vec zauzet
	setm.b	[w1]			; zauzima sprat
	mov	w1,PLSPRAT

	mov	#34,w1
	mulw.uu	w0,w1,w2
	add	#6,w2
	mov	w2,PILLARLY

	mov	#380,w0
	mov	w0,PILLARLX

	clr	PILLARLCOUNT
	bset	FA,#2			; bit 3 = set ako je akrep CATTERPILLAR LEFT u akciji
	bra	cplexit
vecjein.cl:			;
	mov	#24,w0			; za toliko ce se posle 48 koraka menjati PILLARLX
	inc.b	PILLARLCOUNT
	mov	PILLARLCOUNT,w1
	cp	w1,#48
	bra	nc,1f
	clr	PILLARLCOUNT		; limitira na 0...47
	ifc
	sub	PILLARLX		; posle 48 koraka, X se umanjuje za 24
;	tirli2	s.pillar.hi
1:
;	cp	w1,#24
;	ifz
;	tirli2	s.pillar.lo

	mov	PILLARLX,w0
	btss	w0,#15
	bra	noplend
	add.b	#52,w0
	bra	c,noplend
					; ovde je pillar izasao iz ekrana (PILLARLX < -52)
	bclr	FA,#2			; bit 2 = set ako je akrep CATTERPILLAR LEFT u akciji
	mov	#-70,w0
	mov	w0,PILLARLY		; vanished
	mov	#999,w0
	mov	w0,PILLARLX		; da bude van X opsega, da rastereti vga rutinu

	mov	PLSPRAT,w1
	clr.b	[w1]
noplend:
	mov	PILLARLCOUNT,w0
	mov	#26*10,w1		; toliki je jedan sprajt u bajtovima
	mulw.uu	w0,w1,w0

	mov	#psvoffset(pillar)+26*10*47,w1	; to je offset poslednjeg sprajta
	sub	w1,w0,w7		; point na tekuci sprajt

	mov	#SPRITELIST+3*12,w3	; PILLAR LEFT zauzima 4.sprajt

	mov	PILLARLX,w0
	mov	w0,[w3++]		; +0  X pos sprajta (od leve ivice)
	mov	PILLARLY,w0
	add	#17,w0
	mov	w0,[w3++]		; +2  Y pos sprajta (od GORNJE ivice)

	mov	#52,w0
	mov	w0,[w3++]		; +4  sirina sprajta
	mov	#10,w0
	mov	w0,[w3++]		; +6  visina sprajta

	mov	w7,[w3++]		; +8  adresa sprajta u romu
	mov	#psvpage(pillar),w0
	mov	w0,[w3++]		; +10  stranica
;				CATERPILLAR LEFT COLLISION TEST

	mov	JACKX,w0
	add	#10,w0			; jer je tu centar jacka
	mov	PILLARLX,w1
	add	#26,w1			; jer je tu centar pillara
	sub	w0,w1,w0
	btsc	w0,#15
	neg	w0,w0
	cp	w0,#15
	bra	c,catcollexit

	mov	REALY,w0
	mov	PILLARLY,w1
	sub	w0,w1,w0
	btsc	w0,#15
	neg	w0,w0
	cp	w0,#10
	bra	c,catcollexit

	mov	PLAYPTRDOWN,w0
	cp	w0,#25
	bra	c,catcollexit		; \	; jer je down pri kraju

	btss	FLAG,#15		; bit 15 = shield on
	bset	FLAG,#1		; FLAG,#1 = set if hit by enemy, clr if dropped thru hole
	btss	FLAG,#15		; bit 15 = shield on
	bset	FLAG,#7			; FLAG,#7 = FALL flag (sam ce se resetovati)
cplexit:
catcollexit:
;____________________________CATTERPILLAR RIGHT_______________________________________________________

	btsc	FA,#3			; bit 3 = set ako je akrep CATTERPILLAR RIGHT u akciji
	bra	vecjein.cr

	mov	VGAUNIFORM,w1
	and	#63,w1
	bra	nz,cprexit
	mov	RATE,w1			; verovatnoca pojavljivanja, 1=na 1s, 2=na 2s, itd
	call	rndrange
	cp0	w0
	bra	nz,cprexit
					; akrep se inicijalizuje
	mov	#6,w1
	call	rndrange		; u w0 je sprat 0...5

	mov	#ZAUZETI,w1
	add	w0,w1,w1
	cp0.b	[w1]
	bra	nz,cprexit		; jer je taj sprat vec zauzet
	setm.b	[w1]			; zauzima sprat
	mov	w1,PRSPRAT

	mov	#34,w1
	mulw.uu	w0,w1,w2
	add	#6,w2
	mov	w2,PILLARRY

	mov	#-52,w0
	mov	w0,PILLARRX

	clr	PILLARRCOUNT
	bset	FA,#3			; bit 3 = set ako je akrep CATTERPILLAR RIGHT u akciji
	bra	cprexit
vecjein.cr:			;
	mov	#24,w0			; za toliko ce se posle 48 koraka menjati PILLARRX
	inc.b	PILLARRCOUNT
	mov	PILLARRCOUNT,w1
	cp	w1,#48
	bra	nc,1f
	clr	PILLARRCOUNT		; limitira na 0...47
	ifc
	add	PILLARRX		; posle 48 koraka, X se uvecava za 24
;	tirli2	s.pillar.hi
1:
;	cp	w1,#24
;	ifz
;	tirli2	s.pillar.lo

	mov	PILLARRX,w0
	btsc	w0,#15
	bra	noprend
	mov	#380,w1
	cp	w0,w1
	bra	nc,noprend
					; ovde je pillar izasao iz ekrana (PILLARRX > 379)
	bclr	FA,#3			; bit 3 = set ako je akrep CATTERPILLAR RIGHT u akciji
	mov	#-70,w0
	mov	w0,PILLARRY		; vanished
	mov	#999,w0
	mov	w0,PILLARRX		; da bude van X opsega, da rastereti vga rutinu

	mov	PRSPRAT,w1
	clr.b	[w1]
noprend:
	mov	PILLARRCOUNT,w0
	mov	#26*10,w1		; toliki je jedan sprajt u bajtovima
	mulw.uu	w0,w1,w0

	mov	#psvoffset(pillar),w1	; to je offset prvog sprajta
	add	w1,w0,w7		; point na tekuci sprajt

	mov	#SPRITELIST+4*12,w3	; PILLAR LEFT zauzima 5.sprajt

	mov	PILLARRX,w0
	mov	w0,[w3++]		; +0  X pos sprajta (od leve ivice)
	mov	PILLARRY,w0
	add	#17,w0
	mov	w0,[w3++]		; +2  Y pos sprajta (od GORNJE ivice)

	mov	#52,w0
	mov	w0,[w3++]		; +4  sirina sprajta
	mov	#10,w0
	mov	w0,[w3++]		; +6  visina sprajta

	mov	w7,[w3++]		; +8  adresa sprajta u romu
	mov	#psvpage(pillar),w0
	mov	w0,[w3++]		; +10  stranica
;				CATERPILLAR RIGHT COLLISION TEST

	mov	JACKX,w0
	add	#10,w0			; jer je tu centar jacka
	mov	PILLARRX,w1
	add	#26,w1			; jer je tu centar pillara
	sub	w0,w1,w0
	btsc	w0,#15
	neg	w0,w0
	cp	w0,#15
	bra	c,catcolrexit

	mov	REALY,w0
	mov	PILLARRY,w1
	sub	w0,w1,w0
	btsc	w0,#15
	neg	w0,w0
	cp	w0,#10
	bra	c,catcolrexit

	mov	PLAYPTRDOWN,w0
	cp	w0,#25
	bra	c,catcolrexit		; \	; jer je down pri kraju

	btss	FLAG,#15		; bit 15 = shield on
	bset	FLAG,#1		; FLAG,#1 = set if hit by enemy, clr if dropped thru hole
	btss	FLAG,#15		; bit 15 = shield on
	bset	FLAG,#7			; FLAG,#7 = FALL flag (sam ce se resetovati)
cprexit:
catcolrexit:

;____________________________POGO LEFT_______________________________________________________

	btsc	FA,#4			; bit 4 = set ako je akrep POGO LEFT u akciji
	bra	vecjein.pogol

	mov	VGAUNIFORM,w1
	and	#63,w1
	bra	nz,pogolexit
	mov	RATE,w1			; verovatnoca pojavljivanja, 1=na 1s, 2=na 2s, itd
	call	rndrange
	cp0	w0
	bra	nz,pogolexit
					; akrep se inicijalizuje
	mov	#6,w1
	call	rndrange		; u w0 je sprat 0...5

	mov	#ZAUZETI,w1
	add	w0,w1,w1
	cp0.b	[w1]
	bra	nz,pogolexit		; jer je taj sprat vec zauzet
	setm.b	[w1]			; zauzima sprat
	mov	w1,PGLSPRAT

	mov	#34,w1
	mulw.uu	w0,w1,w2
	add	#6,w2
	mov	w2,POGOLY

	mov	#380,w0
	mov	w0,POGOLX

	clr	PGLCOUNT
	bset	FA,#4			; bit 4 = set ako je akrep POGO LEFT u akciji
	bra	pogolexit
vecjein.pogol:			;
	mov	#4,w0			; za toliko ce se posle 4 koraka menjati POGOX
	inc.b	PGLCOUNT
	mov	PGLCOUNT,w1
	cp	w1,#52
	ifc
	clr	PGLCOUNT		; limitira na 0...51

	mov	PGLCOUNT,w1
	and	#3,w1
	ifz
	sub	POGOLX			; umanjuje za 4

	mov	PGLCOUNT,w1
	cp	w1,#26
	bra	nz,1f
	tirli2	s.pogo
1:
	mov	POGOLX,w0
	btss	w0,#15
	bra	nopogolend
	add.b	#16,w0
	bra	c,nopogolend
					; ovde je pogo izasao iz ekrana (POGOLX < -16)
	bclr	FA,#4			; bit 4 = set ako je akrep POGO LEFT u akciji
	mov	#-70,w0
	mov	w0,POGOLY		; vanished
	mov	#999,w0
	mov	w0,POGOLX		; da bude van X opsega, da rastereti vga rutinu

	mov	PGLSPRAT,w1
	clr.b	[w1]
nopogolend:
	mov	PGLCOUNT,w0
	mov	#8*30,w1		; toliki je jedan sprajt u bajtovima
	mulw.uu	w0,w1,w0

	mov	#psvoffset(pogoleft),w1	; to je offset prvog sprajta
	add	w1,w0,w7		; point na tekuci sprajt

	mov	#SPRITELIST+5*12,w3	; POGO LEFT zauzima 6.sprajt

	mov	POGOLX,w0
	mov	w0,[w3++]		; +0  X pos sprajta (od leve ivice)
	mov	POGOLY,w0
	sub	#3,w0
	mov	w0,[w3++]		; +2  Y pos sprajta (od GORNJE ivice)

	mov	#16,w0
	mov	w0,[w3++]		; +4  sirina sprajta
	mov	#30,w0
	mov	w0,[w3++]		; +6  visina sprajta

	mov	w7,[w3++]		; +8  adresa sprajta u romu
	mov	#psvpage(pogoleft),w0
	mov	w0,[w3++]		; +10  stranica
;				POGO LEFT COLLISION TEST

	mov	JACKX,w0
	add	#10,w0			; jer je tu centar jacka
	mov	POGOLX,w1
	add	#8,w1			; jer je tu centar pogoa
	sub	w0,w1,w0
	btsc	w0,#15
	neg	w0,w0
	cp	w0,#15
	bra	c,pogocollexit

	mov	REALY,w0
	mov	POGOLY,w1
	sub	w0,w1,w0
	btsc	w0,#15
	neg	w0,w0
	cp	w0,#6
	bra	c,pogocollexit

	mov	PLAYPTRDOWN,w0
	cp	w0,#25
	bra	c,pogocollexit		; \	; jer je down pri kraju

	btss	FLAG,#15		; bit 15 = shield on
	bset	FLAG,#1		; FLAG,#1 = set if hit by enemy, clr if dropped thru hole
	btss	FLAG,#15		; bit 15 = shield on
	bset	FLAG,#7			; FLAG,#7 = FALL flag (sam ce se resetovati)
pogolexit:
pogocollexit:

;____________________________POGO RIGHT_______________________________________________________

	btsc	FA,#5			; bit 5 = set ako je akrep POGO RIGHT u akciji
	bra	vecjein.pogor

	mov	VGAUNIFORM,w1
	and	#63,w1
	bra	nz,pogorexit
	mov	RATE,w1			; verovatnoca pojavljivanja, 1=na 1s, 2=na 2s, itd
	call	rndrange
	cp0	w0
	bra	nz,pogorexit
					; akrep se inicijalizuje
	mov	#6,w1
	call	rndrange		; u w0 je sprat 0...5

	mov	#ZAUZETI,w1
	add	w0,w1,w1
	cp0.b	[w1]
	bra	nz,pogorexit		; jer je taj sprat vec zauzet
	setm.b	[w1]			; zauzima sprat
	mov	w1,PGRSPRAT

	mov	#34,w1
	mulw.uu	w0,w1,w2
	add	#6,w2
	mov	w2,POGORY

	mov	#-16,w0
	mov	w0,POGORX

	clr	PGRCOUNT
	bset	FA,#5			; bit 5 = set ako je akrep POGO RIGHT u akciji
	bra	pogorexit
vecjein.pogor:			;
	mov	#4,w0			; za toliko ce se posle 4 koraka menjati POGORX
	inc.b	PGRCOUNT
	mov	PGRCOUNT,w1
	cp	w1,#52
	ifc
	clr	PGRCOUNT		; limitira na 0...51

	mov	PGRCOUNT,w1
	and	#3,w1
	ifz
	add	POGORX			; uvecava za 4

	mov	PGRCOUNT,w1
	cp	w1,#26
	bra	nz,1f
	tirli2	s.pogo
1:
	mov	POGORX,w0
	btsc	w0,#15
	bra	nopogorend
	mov	#380,w1
	cp	w0,w1
	bra	nc,nopogorend
					; ovde je pogo izasao iz ekrana (POGORX > 379)
	bclr	FA,#5			; bit 4 = set ako je akrep POGO RIGHT u akciji
	mov	#-70,w0
	mov	w0,POGORY		; vanished
	mov	#999,w0
	mov	w0,POGORX		; da bude van X opsega, da rastereti vga rutinu

	mov	PGRSPRAT,w1
	clr.b	[w1]
nopogorend:
	mov	PGRCOUNT,w0
	mov	#8*30,w1		; toliki je jedan sprajt u bajtovima
	mulw.uu	w0,w1,w0

	mov	#psvoffset(pogoright),w1	; to je offset prvog sprajta
	add	w1,w0,w7		; point na tekuci sprajt

	mov	#SPRITELIST+6*12,w3	; POGO RIGHT zauzima 7.sprajt

	mov	POGORX,w0
	mov	w0,[w3++]		; +0  X pos sprajta (od leve ivice)
	mov	POGORY,w0
	sub	#3,w0
	mov	w0,[w3++]		; +2  Y pos sprajta (od GORNJE ivice)

	mov	#16,w0
	mov	w0,[w3++]		; +4  sirina sprajta
	mov	#30,w0
	mov	w0,[w3++]		; +6  visina sprajta

	mov	w7,[w3++]		; +8  adresa sprajta u romu
	mov	#psvpage(pogoright),w0
	mov	w0,[w3++]		; +10  stranica
;				POGO RIGHT COLLISION TEST

	mov	JACKX,w0
	add	#10,w0			; jer je tu centar jacka
	mov	POGORX,w1
	add	#8,w1			; jer je tu centar pogoa
	sub	w0,w1,w0
	btsc	w0,#15
	neg	w0,w0
	cp	w0,#15
	bra	c,pogocolrexit

	mov	REALY,w0
	mov	POGORY,w1
	sub	w0,w1,w0
	btsc	w0,#15
	neg	w0,w0
	cp	w0,#6
	bra	c,pogocolrexit

	mov	PLAYPTRDOWN,w0
	cp	w0,#25
	bra	c,pogocolrexit		; \	; jer je down pri kraju

	btss	FLAG,#15		; bit 15 = shield on
	bset	FLAG,#1		; FLAG,#1 = set if hit by enemy, clr if dropped thru hole
	btss	FLAG,#15		; bit 15 = shield on
	bset	FLAG,#7			; FLAG,#7 = FALL flag (sam ce se resetovati)
pogorexit:
pogocolrexit:

;____________________________PAPARAMECIUM LEFT_______________________________________________________

	btsc	FA,#6			; bit 6 = set ako je akrep PAPARAMECIUM LEFT u akciji
	bra	vecjein.paral

	mov	VGAUNIFORM,w1
	and	#63,w1
	bra	nz,paralexit
	mov	RATE,w1			; verovatnoca pojavljivanja, 1=na 1s, 2=na 2s, itd
	call	rndrange
	cp0	w0
	bra	nz,paralexit
					; akrep se inicijalizuje
	mov	#6,w1
	call	rndrange		; u w0 je sprat 0...5

	mov	#ZAUZETI,w1
	add	w0,w1,w1
	cp0.b	[w1]
	bra	nz,paralexit		; jer je taj sprat vec zauzet
	setm.b	[w1]			; zauzima sprat
	mov	w1,PARALSPRAT

	mov	#34,w1
	mulw.uu	w0,w1,w2
	add	#24,w2
	mov	w2,PARALY

	mov	#380,w0
	mov	w0,PARALX

	clr	PARALCOUNT
	bset	FA,#6			; bit 6 = set ako je akrep PAPARAMECIUM LEFT u akciji
	bra	paralexit
vecjein.paral:			;
	mov	#4,w0			; za toliko ce se posle 4 koraka menjati PARALX
	inc.b	PARALCOUNT
	mov	PARALCOUNT,w1
	cp	w1,#64
	ifc
	clr	PARALCOUNT		; limitira na 0...63

	mov	PARALCOUNT,w1
	and	#3,w1
	ifz
	sub	PARALX			; umanjuje za 4

;	mov	PARALCOUNT,w1
;	cp	w1,#35
;	bra	nz,1f
;	tirli2	s.para
;1:
	mov	PARALX,w0
	btss	w0,#15
	bra	noparalend
	add.b	#48,w0
	bra	c,noparalend
					; ovde je para izasao iz ekrana (PARALX < -48)
	bclr	FA,#6			; bit 6 = set ako je akrep PAPARAMECIUM LEFT u akciji
	mov	#-70,w0
	mov	w0,PARALY		; vanished
	mov	#999,w0
	mov	w0,PARALX		; da bude van X opsega, da rastereti vga rutinu

	mov	PARALSPRAT,w1
	clr.b	[w1]
noparalend:
	mov	PARALCOUNT,w0
	mov	#24*12,w1		; toliki je jedan sprajt u bajtovima
	mulw.uu	w0,w1,w0

	mov	#psvoffset(para)+24*12*63,w1	; to je offset prvog sprajta
	sub	w1,w0,w7		; point na tekuci sprajt

	mov	#SPRITELIST+7*12,w3	; PAPARAMECIUM LEFT zauzima 8.sprajt

	mov	PARALX,w0
	mov	w0,[w3++]		; +0  X pos sprajta (od leve ivice)
	mov	PARALY,w0
	sub	#3,w0
	mov	w0,[w3++]		; +2  Y pos sprajta (od GORNJE ivice)

	mov	#48,w0
	mov	w0,[w3++]		; +4  sirina sprajta
	mov	#12,w0
	mov	w0,[w3++]		; +6  visina sprajta

	mov	w7,[w3++]		; +8  adresa sprajta u romu
	mov	#psvpage(para),w0
	mov	w0,[w3++]		; +10  stranica
;				PARAMECIUM LEFT COLLISION TEST

	mov	JACKX,w0
	add	#10,w0			; jer je tu centar jacka
	mov	PARALX,w1
	add	#24,w1			; jer je tu centar parameciuma
	sub	w0,w1,w0
	btsc	w0,#15
	neg	w0,w0
	cp	w0,#16
	bra	c,paracollexit

	mov	REALY,w0
	mov	PARALY,w1
	sub	#14,w1			; jer je paramecium za 14 pix nizi od jacka
	sub	w0,w1,w0
	btsc	w0,#15
	neg	w0,w0
	cp	w0,#10
	bra	c,paracollexit

	mov	PLAYPTRDOWN,w0
	cp	w0,#25
	bra	c,paracollexit		; \	; jer je down pri kraju

	btss	FLAG,#15		; bit 15 = shield on
	bset	FLAG,#1		; FLAG,#1 = set if hit by enemy, clr if dropped thru hole
	btss	FLAG,#15		; bit 15 = shield on
	bset	FLAG,#7			; FLAG,#7 = FALL flag (sam ce se resetovati)
paralexit:
paracollexit:

;____________________________PAPARAMECIUM RIGHT_______________________________________________________

	btsc	FA,#7			; bit 7 = set ako je akrep PAPARAMECIUM RIGHT u akciji
	bra	vecjein.parar

	mov	VGAUNIFORM,w1
	and	#63,w1
	bra	nz,pararexit
	mov	RATE,w1			; verovatnoca pojavljivanja, 1=na 1s, 2=na 2s, itd
	call	rndrange
	cp0	w0
	bra	nz,pararexit
					; akrep se inicijalizuje
	mov	#6,w1
	call	rndrange		; u w0 je sprat 0...5

	mov	#ZAUZETI,w1
	add	w0,w1,w1
	cp0.b	[w1]
	bra	nz,pararexit		; jer je taj sprat vec zauzet
	setm.b	[w1]			; zauzima sprat
	mov	w1,PARARSPRAT

	mov	#34,w1
	mulw.uu	w0,w1,w2
	add	#24,w2
	mov	w2,PARARY

	mov	#-48,w0
	mov	w0,PARARX

	clr	PARARCOUNT
	bset	FA,#7			; bit 7 = set ako je akrep PAPARAMECIUM RIGHT u akciji
	bra	pararexit
vecjein.parar:			;
	mov	#4,w0			; za toliko ce se posle 4 koraka menjati PARALX
	inc.b	PARARCOUNT
	mov	PARARCOUNT,w1
	cp	w1,#64
	ifc
	clr	PARARCOUNT		; limitira na 0...63

	mov	PARARCOUNT,w1
	and	#3,w1
	ifz
	add	PARARX			; uvecava za 4

;	mov	PARARCOUNT,w1
;	cp	w1,#35
;	bra	nz,1f
;	tirli2	s.para
;1:
	mov	PARARX,w0
	btsc	w0,#15
	bra	nopararend
	mov	#380,w1
	cp	w0,w1
	bra	nc,nopararend
					; ovde je para izasao iz ekrana (PARARX < -48)
	bclr	FA,#7			; bit 7 = set ako je akrep PAPARAMECIUM RIGHT u akciji
	mov	#-70,w0
	mov	w0,PARARY		; vanished
	mov	#999,w0
	mov	w0,PARARX		; da bude van X opsega, da rastereti vga rutinu

	mov	PARARSPRAT,w1
	clr.b	[w1]
nopararend:
	mov	PARARCOUNT,w0
	mov	#24*12,w1		; toliki je jedan sprajt u bajtovima
	mulw.uu	w0,w1,w0

	mov	#psvoffset(para),w1	; to je offset prvog sprajta
	add	w1,w0,w7		; point na tekuci sprajt

	mov	#SPRITELIST+8*12,w3	; PAPARAMECIUM RIGHT zauzima 9.sprajt

	mov	PARARX,w0
	mov	w0,[w3++]		; +0  X pos sprajta (od leve ivice)
	mov	PARARY,w0
	sub	#3,w0
	mov	w0,[w3++]		; +2  Y pos sprajta (od GORNJE ivice)

	mov	#48,w0
	mov	w0,[w3++]		; +4  sirina sprajta
	mov	#12,w0
	mov	w0,[w3++]		; +6  visina sprajta

	mov	w7,[w3++]		; +8  adresa sprajta u romu
	mov	#psvpage(para),w0
	mov	w0,[w3++]		; +10  stranica
;				PARAMECIUM RIGHT COLLISION TEST

	mov	JACKX,w0
	add	#10,w0			; jer je tu centar jacka
	mov	PARARX,w1
	add	#24,w1			; jer je tu centar parameciuma
	sub	w0,w1,w0
	btsc	w0,#15
	neg	w0,w0
	cp	w0,#16
	bra	c,paracolrexit

	mov	REALY,w0
	mov	PARARY,w1
	sub	#14,w1			; jer je paramecium za 14 pix nizi od jacka
	sub	w0,w1,w0
	btsc	w0,#15
	neg	w0,w0
	cp	w0,#10
	bra	c,paracolrexit

	mov	PLAYPTRDOWN,w0
	cp	w0,#25
	bra	c,paracolrexit		; \	; jer je down pri kraju

	btss	FLAG,#15		; bit 15 = shield on
	bset	FLAG,#1		; FLAG,#1 = set if hit by enemy, clr if dropped thru hole
	btss	FLAG,#15		; bit 15 = shield on
	bset	FLAG,#7			; FLAG,#7 = FALL flag (sam ce se resetovati)
pararexit:
paracolrexit:

;____________________________LIGHTNING LEFT_______________________________________________________

	btsc	FA,#8			; bit 8 = set ako je akrep LIGHTNING LEFT u akciji
	bra	vecjein.ligl

	mov	VGAUNIFORM,w1
	and	#63,w1
	bra	nz,liglexit
	mov	RATE,w1			; verovatnoca pojavljivanja, 1=na 1s, 2=na 2s, itd
	call	rndrange
	cp0	w0
	bra	nz,liglexit
					; akrep se inicijalizuje
	mov	#6,w1
	call	rndrange		; u w0 je sprat 0...5

	mov	#ZAUZETI,w1
	add	w0,w1,w1
	cp0.b	[w1]
	bra	nz,liglexit		; jer je taj sprat vec zauzet
	setm.b	[w1]			; zauzima sprat
	mov	w1,LIGLSPRAT

	mov	#34,w1
	mulw.uu	w0,w1,w2
	add	#2,w2
	mov	w2,LIGLY

	mov	#380,w0
	mov	w0,LIGLX

	clr	LIGLCOUNT		; brojac za lightning nalevo
	bset	FA,#8			; bit 8 = set ako je akrep LIGHTNING LEFT u akciji
	bra	liglexit
vecjein.ligl:			;
	mov	#4,w0			; za toliko ce se posle 4 koraka menjati LIGLX
	inc.b	LIGLCOUNT
	bclr	LIGLCOUNT,#2		; broji 0...3
	cp0	LIGLCOUNT
	ifz
	sub	LIGLX			; umanjuje za 4

	mov	LIGLX,w0
	btss	w0,#15
	bra	noliglend
	add.b	#40,w0
	bra	c,noliglend
					; ovde je lig izasao iz ekrana (LIGLX < -48)
	bclr	FA,#8			; bit 8 = set ako je akrep LIGHTNING LEFT u akciji
	mov	#-70,w0
	mov	w0,LIGLY		; vanished
	mov	#999,w0
	mov	w0,LIGLX		; da bude van X opsega, da rastereti vga rutinu

	mov	LIGLSPRAT,w1
	clr.b	[w1]
noliglend:
	mov	LIGLLAST,w0
	btsc	VGAUNIFORM,#0
	bra	instantl		; ponavlja prethodni lighting sprite

	clr	w1
	mov	SEED+2,w0
	and	#0,w0
	bra	nz,3f			; tu nema munje (prvi sprajt je prazan)
					; dalje postoji munja
	mov	#48,w1
	call	rndrange
	and	#0b11111100,w0
	add	#3,w0
	subr	LIGLCOUNT,WREG

	mov	#20*31,w1		; toliki je jedan sprajt u bajtovima
3:
	mulw.uu	w0,w1,w0
	mov	w0,LIGLLAST
instantl:
	mov	#psvoffset(lightningspr),w1	; to je offset prvog sprajta
	add	w1,w0,w7		; point na tekuci sprajt

	mov	#SPRITELIST+9*12,w3	; LIGHTNING LEFT zauzima 10.sprajt

	mov	LIGLX,w0
	mov	w0,[w3++]		; +0  X pos sprajta (od leve ivice)
	mov	LIGLY,w0
	mov	w0,[w3++]		; +2  Y pos sprajta (od GORNJE ivice)

	mov	#40,w0
	mov	w0,[w3++]		; +4  sirina sprajta
	mov	#31,w0
	mov	w0,[w3++]		; +6  visina sprajta

	mov	w7,[w3++]		; +8  adresa sprajta u romu
	mov	#psvpage(lightningspr),w0
	mov	w0,[w3++]		; +10  stranica
;				LIGHTNING LEFT COLLISION TEST

	mov	JACKX,w0
	add	#10,w0			; jer je tu centar jacka
	mov	LIGLX,w1
	add	#20,w1			; jer je tu centar lig
	sub	w0,w1,w0
	btsc	w0,#15
	neg	w0,w0
	cp	w0,#16
	bra	c,ligcollexit

	mov	REALY,w0
	mov	LIGLY,w1
	add	#4,w1			; jer je lig za 4 pix visi od jacka
	sub	w0,w1,w0
	btsc	w0,#15
	neg	w0,w0
	cp	w0,#10
	bra	c,ligcollexit

	mov	PLAYPTRDOWN,w0
	cp	w0,#25
	bra	c,ligcollexit		; \	; jer je down pri kraju

	btss	FLAG,#15		; bit 15 = shield on
	bset	FLAG,#1		; FLAG,#1 = set if hit by enemy, clr if dropped thru hole
	btss	FLAG,#15		; bit 15 = shield on
	bset	FLAG,#7			; FLAG,#7 = FALL flag (sam ce se resetovati)
liglexit:
ligcollexit:

;____________________________LIGHTNING RIGHT_______________________________________________________

	btsc	FA,#9			; bit 9 = set ako je akrep LIGHTNING RIGHT u akciji
	bra	vecjein.ligr

	mov	VGAUNIFORM,w1
	and	#63,w1
	bra	nz,ligrexit
	mov	RATE,w1			; verovatnoca pojavljivanja, 1=na 1s, 2=na 2s, itd
	call	rndrange
	cp0	w0
	bra	nz,ligrexit
					; akrep se inicijalizuje
	mov	#6,w1
	call	rndrange		; u w0 je sprat 0...5

	mov	#ZAUZETI,w1
	add	w0,w1,w1
	cp0.b	[w1]
	bra	nz,ligrexit		; jer je taj sprat vec zauzet
	setm.b	[w1]			; zauzima sprat
	mov	w1,LIGRSPRAT

	mov	#34,w1
	mulw.uu	w0,w1,w2
	add	#2,w2
	mov	w2,LIGRY

	mov	#-40,w0
	mov	w0,LIGRX

	clr	LIGRCOUNT		; brojac za lightning nalevo
	bset	FA,#9			; bit 9 = set ako je akrep LIGHTNING RIGHT u akciji
	bra	ligrexit
vecjein.ligr:			;
	mov	#4,w0			; za toliko ce se posle 4 koraka menjati LIGRX
	inc.b	LIGRCOUNT
	bclr	LIGRCOUNT,#2		; broji 0...3
	cp0	LIGRCOUNT
	ifz
	add	LIGRX			; uvecava za 4

	mov	LIGRX,w0
	btsc	w0,#15
	bra	noligrend
	mov	#380,w1
	cp	w0,w1
	bra	nc,noligrend
					; ovde je lig izasao iz ekrana (ligRX > 379)
	bclr	FA,#9			; bit 9 = set ako je akrep LIGHTNING RIGHT u akciji
	mov	#-70,w0
	mov	w0,LIGRY		; vanished
	mov	#999,w0
	mov	w0,LIGRX		; da bude van X opsega, da rastereti vga rutinu

	mov	LIGRSPRAT,w1
	clr.b	[w1]
noligrend:
	mov	LIGRLAST,w0
	btsc	VGAUNIFORM,#0
	bra	instantr		; ponavlja prethodni lighting sprite

	clr	w1
	mov	SEED+2,w0
	and	#0,w0
	bra	nz,3f			; tu nema munje (prvi sprajt je prazan)
					; dalje postoji munja
	mov	#48,w1
	call	rndrange
	and	#0b11111100,w0
	add	LIGRCOUNT,WREG
	mov	#20*31,w1		; toliki je jedan sprajt u bajtovima
3:
	mulw.uu	w0,w1,w0
	mov	w0,LIGRLAST
instantr:
	mov	#psvoffset(lightningspr),w1	; to je offset prvog sprajta
	add	w1,w0,w7		; point na tekuci sprajt

	mov	#SPRITELIST+10*12,w3	; LIGHTNING RIGHT zauzima 11.sprajt

	mov	LIGRX,w0
	mov	w0,[w3++]		; +0  X pos sprajta (od leve ivice)
	mov	LIGRY,w0
	mov	w0,[w3++]		; +2  Y pos sprajta (od GORNJE ivice)

	mov	#40,w0
	mov	w0,[w3++]		; +4  sirina sprajta
	mov	#31,w0
	mov	w0,[w3++]		; +6  visina sprajta

	mov	w7,[w3++]		; +8  adresa sprajta u romu
	mov	#psvpage(lightningspr),w0
	mov	w0,[w3++]		; +10  stranica
;				LIGHTNING RIGHT COLLISION TEST

	mov	JACKX,w0
	add	#10,w0			; jer je tu centar jacka
	mov	LIGRX,w1
	add	#20,w1			; jer je tu centar lig
	sub	w0,w1,w0
	btsc	w0,#15
	neg	w0,w0
	cp	w0,#16
	bra	c,ligcolrexit

	mov	REALY,w0
	mov	LIGRY,w1
	add	#4,w1			; jer je lig za 4 pix visi od jacka
	sub	w0,w1,w0
	btsc	w0,#15
	neg	w0,w0
	cp	w0,#10
	bra	c,ligcolrexit

	mov	PLAYPTRDOWN,w0
	cp	w0,#25
	bra	c,ligcolrexit		; \	; jer je down pri kraju

	btss	FLAG,#15		; bit 15 = shield on
	bset	FLAG,#1		; FLAG,#1 = set if hit by enemy, clr if dropped thru hole
	btss	FLAG,#15		; bit 15 = shield on
	bset	FLAG,#7			; FLAG,#7 = FALL flag (sam ce se resetovati)
ligrexit:
ligcolrexit:



















;____________________________CUBE LEFT_______________________________________________________

	btsc	FA,#12			; bit 12 = set ako je CUBE LEFT u akciji
	bra	vecjein.cubel

	mov	VGAUNIFORM,w1
	and	#63,w1
	bra	nz,cubelexit
	mov	CUBERATE,w1			; verovatnoca pojavljivanja, 1=na 1s, 2=na 2s, itd

	sl	w1,#2,w1			;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; redje

	call	rndrange
	cp0	w0
	bra	nz,cubelexit
					; cube se inicijalizuje
	mov	#6,w1
	call	rndrange		; u w0 je sprat 0...5

	mov	#ZAUZETI,w1
	add	w0,w1,w1
	cp0.b	[w1]
	bra	nz,cubelexit		; jer je taj sprat vec zauzet
	setm.b	[w1]			; zauzima sprat
	mov	w1,CUBELSPRAT

	mov	#34,w1
	mulw.uu	w0,w1,w2
	add	#8,w2				; cube left vert pos
	mov	w2,CUBELY

	mov	#380,w0
	mov	w0,CUBELX

	bclr	F2,#10	; #10 = set ako je upravo dobio zivot, da se ne ponovi
	clr	CUBELCOUNT		; brojac za CUBE nalevo
	bset	FA,#12			; bit 12 = set ako je CUBE LEFT u akciji
vecjein.cubel:			;
	mov	#4,w0			; za toliko ce se posle 4 koraka menjati CUBELX
	inc	CUBELCOUNT
	mov	CUBELCOUNT,w1
	cp	w1,#100
	ifz
	clr	CUBELCOUNT

	and	#3,w1
	ifz
	sub	CUBELX			; umanjuje za 4

	mov	CUBELX,w0
	btss	w0,#15
	bra	nocubelend
	add.b	#24,w0
	bra	c,nocubelend
					; ovde je CUBE izasao iz ekrana (CUBELX < -24)
	bclr	FA,#12			; bit 12 = set ako je CUBE LEFT u akciji
	mov	#-70,w0
	mov	w0,CUBELY		; vanished
	mov	#999,w0
	mov	w0,CUBELX		; da bude van X opsega, da rastereti vga rutinu

	bclr	F2,#10	; #10 = set ako je upravo dobio zivot, da se ne ponovi
	mov	CUBELSPRAT,w1
	clr.b	[w1]
nocubelend:
	mov	#psvoffset(cuberotate),w1	; to je offset prvog sprajta
	mov	CUBELCOUNT,w0
	mov	#24*10,w7
	mulw.uu	w0,w7,w0
	add	w1,w0,w7

	mov	#SPRITELIST+11*12,w3	; CUBE LEFT zauzima 12.sprajt

	mov	CUBELX,w0
	mov	w0,[w3++]		; +0  X pos sprajta (od leve ivice)
	mov	CUBELY,w0
	mov	w0,[w3++]		; +2  Y pos sprajta (od GORNJE ivice)

	mov	#24,w0
	mov	w0,[w3++]		; +4  sirina sprajta
	mov	#20,w0
	mov	w0,[w3++]		; +6  visina sprajta

	mov	w7,[w3++]		; +8  adresa sprajta u romu
	mov	#psvpage(cuberotate),w0
	mov	w0,[w3++]		; +10  stranica
;				CUBE LEFT COLLISION TEST

	mov	JACKX,w0
	add	#10,w0			; jer je tu centar jacka
	mov	CUBELX,w1
	add	#12,w1			; jer je tu centar CUBE
	sub	w0,w1,w0
	btsc	w0,#15
	neg	w0,w0
	cp	w0,#16
	bra	c,cubecollexit

	mov	REALY,w0
	mov	CUBELY,w1
	sub	w0,w1,w0
	btsc	w0,#15
	neg	w0,w0
	cp	w0,#10
	bra	c,cubecollexit

	btsc	F2,#10	; #10 = set ako je upravo dobio zivot, da se ne ponovi
	bra	cubecollexit

	bset	F2,#10	; #10 = set ako je upravo dobio zivot, da se ne ponovi
	mov	LIVES,w0
	cp	w0,#99
	manji
	inc	LIVES
	mov	#133,w0
	mov	w0,WHITELIVES
	call	printlives

	tirli1 newlife

cubelexit:
cubecollexit:


;____________________________CUBE RIGHT_______________________________________________________

	btsc	FA,#13			; bit 13 = set ako je CUBE RIGHT u akciji
	bra	vecjein.cuber

	mov	VGAUNIFORM,w1
	and	#63,w1
	bra	nz,cuberexit
	mov	CUBERATE,w1			; verovatnoca pojavljivanja, 1=na 1s, 2=na 2s, itd

	sl	w1,#2,w1			;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; redje

	call	rndrange
	cp0	w0
	bra	nz,cuberexit
					; cube se inicijalizuje
	mov	#6,w1
	call	rndrange		; u w0 je sprat 0...5

	mov	#ZAUZETI,w1
	add	w0,w1,w1
	cp0.b	[w1]
	bra	nz,cuberexit		; jer je taj sprat vec zauzet
	setm.b	[w1]			; zauzima sprat
	mov	w1,CUBERSPRAT

	mov	#34,w1
	mulw.uu	w0,w1,w2
	add	#8,w2				; cube left vert pos
	mov	w2,CUBERY

	mov	#-24,w0
	mov	w0,CUBERX

	bclr	F2,#11	; #11 = set ako je upravo dobio zivot, da se ne ponovi
	clr	CUBERCOUNT		; brojac za CUBE nadesno
	bset	FA,#13			; bit 13 = set ako je CUBE RIGHT u akciji
vecjein.cuber:			;
	mov	#4,w0			; za toliko ce se posle 4 koraka menjati CUBELX
	inc	CUBERCOUNT
	mov	CUBERCOUNT,w1
	cp	w1,#100
	ifz
	clr	CUBERCOUNT

	mov	CUBERCOUNT,w1
	and	#3,w1
	ifz
	add	CUBERX			; uvecava X pos za 4

	mov	CUBERX,w0
	btsc	w0,#15
	bra	nocuberend
	mov	#380,w1
	cp	w0,w1
	bra	nc,nocuberend
					; ovde je CUBE izasao iz ekrana (CUBERX < -24)
	bclr	FA,#13			; bit 13 = set ako je CUBE RIGHT u akciji
	mov	#-70,w0
	mov	w0,CUBERY		; vanished
	mov	#999,w0
	mov	w0,CUBERX		; da bude van X opsega, da rastereti vga rutinu

	bclr	F2,#11	; #11 = set ako je upravo dobio zivot, da se ne ponovi
	mov	CUBERSPRAT,w1
	clr.b	[w1]
nocuberend:
	mov	#psvoffset(cuberotate)+24*10*99,w1	; to je offset poslednjeg sprajta
	mov	CUBERCOUNT,w0
	mov	#24*10,w7
	mulw.uu	w0,w7,w0
	sub	w1,w0,w7

	mov	#SPRITELIST+12*12,w3	; CUBE RIGHT zauzima 13.sprajt

	mov	CUBERX,w0
	mov	w0,[w3++]		; +0  X pos sprajta (od leve ivice)
	mov	CUBERY,w0
	mov	w0,[w3++]		; +2  Y pos sprajta (od GORNJE ivice)

	mov	#24,w0
	mov	w0,[w3++]		; +4  sirina sprajta
	mov	#20,w0
	mov	w0,[w3++]		; +6  visina sprajta

	mov	w7,[w3++]		; +8  adresa sprajta u romu
	mov	#psvpage(cuberotate),w0
	mov	w0,[w3++]		; +10  stranica
;				CUBE RIGHT COLLISION TEST

	mov	JACKX,w0
	add	#10,w0			; jer je tu centar jacka
	mov	CUBERX,w1
	add	#12,w1			; jer je tu centar CUBE
	sub	w0,w1,w0
	btsc	w0,#15
	neg	w0,w0
	cp	w0,#16
	bra	c,cubecolrexit

	mov	REALY,w0
	mov	CUBERY,w1
	sub	w0,w1,w0
	btsc	w0,#15
	neg	w0,w0
	cp	w0,#10
	bra	c,cubecolrexit

	btsc	F2,#11	; #11 = set ako je upravo dobio zivot, da se ne ponovi
	bra	cubecolrexit

	bset	F2,#11	; #11 = set ako je upravo dobio zivot, da se ne ponovi
	mov	LIVES,w0
	cp	w0,#99
	manji
	inc	LIVES
	mov	#133,w0
	mov	w0,WHITELIVES
	call	printlives

	tirli1 newlife

cuberexit:
cubecolrexit:
















; </editor-fold>
;<editor-fold defaultstate="collapsed" desc="vertical enemies">

;____________________________VERTICAL ENEMIES_______________________________________________________

	btsc	FA,#15			; bit 15 = set if vertical enemy in action
	bra	vecjein.vert1

	cp0	JACKFLOOR
	bra	z,vertexit		; ne razmatra uvodjenje vert enemy dok je jack na ground level

	mov	VGAUNIFORM,w1
	and	#63,w1
	bra	nz,vertexit
	mov	VERTRATE,w1			; verovatnoca pojavljivanja, 1=na 1s, 2=na 2s, itd (if vgauniform and #63)
	call	rndrange
	cp0	w0
	bra	nz,vertexit

	cp0	JACKFLOOR
;	bra	z,vertexit		; no enemy if Jack is on the ground level;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
					; akrep se inicijalizuje
	mov	#4,w1			; ukupni broj vertikalnih padalica
	call	rndrange
	mov	w0,VERTENEMY	; enemy type

	tirli2	vertenemystart

	mov	#328/4,w1
	call	rndrange
	sl	w0,#2,w0		; Xpos rounded to step 4
	add	#20,w0
	mov	w0,VERTX		; VERTX in range 20-344 step 4

	mov	#-28,w0
	mov	w0,VERTY

	clr	VERTCOUNT		; vert enemy counter
	clr	VERTINNER		; vert enemy inner counter
	bset	FA,#15			; bit 15 = set, vertical enemy in action
	bra	vertexit
vecjein.vert1:			;
	mov	VERTY,w0
	add	#2,w0			; step of vertical enemy falling (in pixels)
	mov	w0,VERTY
	btsc	w0,#15
	bra	novertend
	cp	w0,#240
	bra	nc,novertend
					; ovde je vert enemy izasao iz ekrana (VERTY > -240)
	bclr	FA,#15			; bit 15 = set if vertical enemy in action
	mov	#999,w0
	mov	w0,VERTX		; vanished (da bude van X opsega, da rastereti vga rutinu)
	mov	#-99,w0
	mov	w0,VERTY

	tirli2	vertenemyend
novertend:

	btsc	VGAUNIFORM,#0
	bra	novertinc

	mov	VERTENEMY,w12
	cp	w12,#0
	bra	nz,1f
					; vert enemy 0: meteor ***************************************
	inc	VERTCOUNT,WREG
	and	#15,w0
	mov	w0,VERTCOUNT
	bra	novertinc		; \\\
1:
	cp	w12,#1
	bra	nz,1f
						; vert enemy 1: teg ******************************************
	btsc	VGAUNIFORM,#1	; usporava ljuljanje tega
	bra	novertinc

	btss	VERTINNER,#0	; if bit #0 set, then vertcount backwards
	bra	2f
	dec	VERTCOUNT
	cp0	VERTCOUNT
	ifz
	bclr	VERTINNER,#0	; if bit #0 set, then vertcount backwards
	bra	novertinc		; \\\
2:
	inc	VERTCOUNT
	mov	VERTCOUNT,w0
	cp	w0,#15
	ifc
	bset	VERTINNER,#0	; if bit #0 set, then vertcount backwards
	bra	novertinc		; \\\
1:
	cp	w12,#2
	bra	nz,1f
						; vert enemy 3: saksija *************************************
	btss	VERTINNER,#0	; if bit #0 set, then vertcount backwards
	bra	2f
	dec	VERTCOUNT
	cp0	VERTCOUNT
	ifz
	bclr	VERTINNER,#0	; if bit #0 set, then vertcount backwards
	bra	novertinc		; \\\
2:
	inc	VERTCOUNT
	mov	VERTCOUNT,w0
	cp	w0,#15
	ifc
	bset	VERTINNER,#0	; if bit #0 set, then vertcount backwards
	bra	novertinc		; \\\
1:
	cp	w12,#3
	bra	nz,1f
						; vert enemy 4: pegla **************************************
	btss	VERTINNER,#0	; if bit #0 set, then vertcount backwards
	bra	2f
	dec	VERTCOUNT
	cp0	VERTCOUNT
	ifz
	bclr	VERTINNER,#0	; if bit #0 set, then vertcount backwards
	bra	novertinc		; \\\
2:
	inc	VERTCOUNT
	mov	VERTCOUNT,w0
	cp	w0,#15
	ifc
	bset	VERTINNER,#0	; if bit #0 set, then vertcount backwards
	bra	novertinc		; \\\
1:

novertinc:				; ///
	mov	VERTCOUNT,w0
	mov	#16*12,w1		; toliki je jedan sprajt u bajtovima
	mulw.uu	w0,w1,w0	; offset tekuceg sprajta u odnosu na prvi
	mov	#psvoffset(padalice),w1	; to je offset prvog sprajta
	add	w1,w0,w7		; point na tekuci sprajt

	mov	VERTENEMY,w0	; enemy type
	mov	##16*12*16,w1	; tolika je cela sekvenca (16 sprites) jednog neprijatelja u bajtovima
	mulw.uu	w0,w1,w0
	add	w7,w0,w7

	mov	#SPRITELIST+16*12,w3	; padalice zauzimaju 17.sprajt

	mov	VERTX,w0
	mov	w0,[w3++]		; +0  X pos sprajta (od leve ivice)
	mov	VERTY,w0
	mov	w0,[w3++]		; +2  Y pos sprajta (od GORNJE ivice)

	mov	#16,w0
	mov	w0,[w3++]		; +4  sirina sprajta
	mov	#24,w0
	mov	w0,[w3++]		; +6  visina sprajta

	mov	w7,[w3++]		; +8  adresa sprajta u romu
	mov	#psvpage(padalice),w0
	mov	w0,[w3++]		; +10  stranica
;				VERT ENEMY COLLISION TEST			

	cp0	JACKFLOOR
	bra	z,vertcolexit		; no collision if jack is on the ground level
	btsc	FLAG,#10		; FLAG,#10 = jack in elevator
	bra	z,vertcolexit		; no collision if jack in elevator

	mov	JACKX,w0
	add	#10,w0			; jer je tu centar jacka
	mov	VERTX,w1
	add	#8,w1			; jer je tu centar vert
	sub	w0,w1,w0
	btsc	w0,#15
	neg	w0,w0
	cp	w0,#11			; X tolerance
	bra	c,vertcolexit

	mov	REALY,w0
	mov	VERTY,w1
	sub	w0,w1,w0
	btsc	w0,#15
	neg	w0,w0
	cp	w0,#5
	bra	c,vertcolexit	; Y tolerance

	mov	PLAYPTRDOWN,w0
	cp	w0,#25
	bra	c,vertcolexit		; \	; jer je down pri kraju

	btss	FLAG,#15		; bit 15 = shield on
	bset	FLAG,#1		; FLAG,#1 = set if hit by enemy, clr if dropped thru hole
	btss	FLAG,#15		; bit 15 = shield on
	bset	FLAG,#7			; FLAG,#7 = FALL flag (sam ce se resetovati)
vertexit:
vertcolexit:


; </editor-fold>
;<editor-fold defaultstate="collapsed" desc="limitira JACKX na 16-352 i zove liftove">

;			limitira JACKX na 16-352 i zove liftove
;_______________________________________________________________________________________________

	btsc	FLAG,#10	; FLAG,#10 = jack u liftu
	bra	notrightlift	; ako je vec u liftu, onda nista ne vazi

	mov	JACKY,w0
	sub	#6,w0
	cp	LIFT1Y
	mov	#16,w2		; ako LEVI lift nije na visini jacka
	ifz
	mov	#16-12,w2	; ako je LEVI lift na visini jacka

	mov	JACKX,w0
	cp	w0,w2		; test da li je manji od 16 ili 4
	manji
	mov	w2,JACKX	; jeste, inicijalizuj 16 ili 4

	mov	JACKY,w0
	sub	#6,w0
	cp	LIFT2Y
	mov	#352,w2		; ako DESNI lift nije na visini jacka
	ifz
	mov	#352+16,w2	; ako je DESNI lift na visini jacka
	inc	w2,w1

	mov	JACKX,w0
	cp	w0,w1		; test da li je veci od 352 ili 368
	istiveci
	mov	w2,JACKX	; jeste, inicijalizuj 352 ili 368

	mov	JACKX,w0
	cp	w0,#16		; test da li je =16
	bra	nz,notleftlift
				; jeste, pozovi levi lift
	mov	#6,w0
	subr	JACKFLOOR,WREG	; 6-jackfloor ---> w0
	mov	#34,w1
	mulw.uu	w0,w1,w0
	btss	FLAG,#10	; FLAG,#10 = jack u liftu
	mov	w0,LIFT1TARGET	; ako vec nije u liftu, onda ga poziva
notleftlift:
	mov	#352,w1
	mov	JACKX,w0
	cp	w0,w1		; test da li je =352
	bra	nz,notrightlift
				; jeste, pozovi desni lift
	mov	#6,w0
	subr	JACKFLOOR,WREG	; 6-jackfloor ---> w0
	mov	#34,w1
	mulw.uu	w0,w1,w0
	btss	FLAG,#10	; FLAG,#10 = jack u liftu
	mov	w0,LIFT2TARGET	; ako vec nije u liftu, onda ga poziva
notrightlift:
		;	testira da li treba nacrtati jackov profil u liftu
	bclr	FLAG,#10		; FLAG,#10 = jack u liftu

	mov	JACKX,w0
	mov	#psvoffset(liftleft),w4
	cp	w0,#10
	bra	nc,lrlift		; ako je jackx < 10
	mov	#psvoffset(liftright),w4
	mov	#362,w1
	cp	w0,w1
	bra	nc,noprofil		; jer nije ni u jednom liftu
lrlift:
	cp0	PLAYPTRFALL
	bra	nz,nijeupalio

	mov	#SPRITELIST+17*12,w3	; Jack zauzima 18. sprajt (SPRITELIST+17*12)
	clr	SPRITECOUNT		; clear brojac faze pokreta
	clr	PLAYPTR			; clear brojac sekvence za cesanje po glavi dok stoji
	clr	PLAYPTRJUMP		; clear brojac sekvence za skok
	clr	PLAYPTRDOWN		; clear brojac sekvence za down

	mov	JACKX,w0
	mov	w0,[w3++]		; +0  X pos sprajta (od leve ivice)
	mov	JACKY,w0
	mov	w0,REALY
	mov	w0,[w3++]		; +2  Y pos sprajta (od GORNJE ivice)

	mov	#8,w0
	mov	w0,[w3++]		; +4  sirina sprajta
	mov	#27,w0
	mov	w0,[w3++]		; +6  visina sprajta

	mov	w4,[w3++]		; +8  adresa sprajta u romu (liftleft ili liftright)
	mov	#psvpage(liftleft),w0
	mov	w0,[w3++]		; +10  stranica

	mov	#30,w0			; preset LIFTPATIENCE u prvom trenutku ulaska u lift
	btss	F2,#1		; F1,#2 = prethodno stanje FLAG,#10 (za detekciju trenutka ulaska u lift)
	mov	w0,LIFTPATIENCE		; prvi trenutak ulaska u lift
	bset	FLAG,#10		; FLAG,#10 = jack u liftu
noprofil:
	bclr	F2,#1		; F1,#2 = prethodno stanje FLAG,#10 (za detekciju trenutka ulaska u lift)
	btsc	FLAG,#10		; FLAG,#10 = jack u liftu
	bset	F2,#1
; sprecava da se ponovljeno uvecava nivo
	btss	FLAG,#12	; set ako je upaljeno svetlo u levom
	bra	3f
	btsc	FLAG,#13	; set ako je upaljeno svetlo u desnom
	bra	nijeupalio	; da ne testira vise ako je vec izvrsio zadatak
3:
; sledi test da li je upalio svetlo u liftu
	btss	FLAG,#10		; FLAG,#10 = jack u liftu
	bra	nijeupalio		; jer nije u liftu

	mov	JACKY,w0
	cp	w0,#6+2
	bra	c,nijeupalio		; jer nije na 6. spratu

	mov	JACKX,w0
	cp	w0,#380/2
	bra	c,palidrugi		; ipak je desni
					; ako je levi lift...
	btsc	FLAG,#12
	bra	1f
	tirli1	upalio
1:
	bset	FLAG,#12		; ...pali svetlo u levom
	call	drawlift1
	bclr	F2,#6		; #6 = set ako su vec bile fanfare
	btss	FLAG,#13
	bra	nijeupalio
	mov	#4,w0
	mov	w0,JACKX		; da bude strogo u levom
	bra	newlevel	; zavrsen zadatak - ide na novi nivo
palidrugi:				; ako je desni lift...
	btsc	FLAG,#13
	bra	1f
	tirli1	upalio
1:
	bset	FLAG,#13		; ...pali svetlo u desnom
	call	drawlift2
	bclr	F2,#6		; #6 = set ako su vec bile fanfare
	btss	FLAG,#12
	bra	nijeupalio
	mov	#368,w0
	mov	w0,JACKX		; da bude strogo u desnom
	bra	newlevel	; zavrsen zadatak - ide na novi nivo
nijeupalio:
;</editor-fold>
; <editor-fold desc="test da li je jack na rupi">
;												
;			test da li je jack na rupi						
;_______________________________________________________________________________________________

	btsc	FLAG,#15	; FLAG,#15 = shield	
	bra	nofall      ; *	; ne testira rupe jer ima shield

	mov	JACKX,w0
	cp	w0,#12
	bra	nc,nofall   ; *	; ne testira rupe jer je u levom liftu
	mov	#360+1,w1
	cp	w0,w1
	bra	c,nofall    ; *	; ne testira rupe jer je u desnom liftu

	cp0	PLAYPTRJUMP
	bra	z,2f	; \	; jer jump nije u toku
	mov	PLAYPTRJUMP,w0
	cp	w0,#7
	bra	nc,2f	; /	; pad je moguc jer je na pocetku skoka

;	cp	w0,#45		; a mozda ovo pomogne?
;	ifz			; a mozda ovo pomogne?
;	bclr	FLAG,#7		; a mozda ovo pomogne?

	bra	nc,nofall	; No fall jer je u toku jump i frame je izmedju 7 i 45 (total=46 frames)
2:
	cp0	PLAYPTRFALL
	bra	z,1f	; \	; jer pad nije u toku
	mov	PLAYPTRFALL,w0
	cp	w0,#46		; jer je posle 46. frejma na zemlji, pa moze ponovo da pada
	bra	nc,nofall	; jer je pad u toku i frejm je <46
1:			; /	; dalje testira da li je na rupi
	cp0	PLAYPTRDOWN
	bra	nz,nofall	; \	; ne testira jer je down u toku

	mov	BROJRUPA,w9
	cp0	w9
	bra	z,nofall
	mov	#RUPE,w8	; +0: hole X-pos 0...173 (>173: no hole), +2: line number 0...5 (>5: no hole)
9:			; \
	mov	[w8+2],w0	; tested hole line number 0...5

	cp0	SPIDERCOUNT
	bra	z,nospider
						; ovde pomera za 1 sprat jer je zakacen na plafon
	mov	SPIDERCOUNT,w1
	cp	w1,#11
	bra	nz,nofall		; nofall jer je spider skok u toku

	inc	w0,w0			; pomera testirani nivo za 1 sprat nadole jer je jack zakacen na plafon

nospider:

	add	JACKFLOOR,WREG	; line on which the tested hole is (from the top) + floor on which jack is
	cp	w0,#6
	bra	nz,2f	; \\	; tested hole is NOT on jack's floor
	sl	[w8],w0		; 2x, makes hole X-pos 0...346 (in pixels)
	add	#16-0,w0	; real hole position (skip elevator) - jack's X center (in pixels)

	mov	JACKX,w1	; jack's X-pos 0...326 (in pixels)
	sub	w1,w0,w0	; jack's X offset from the left hole edge

	cp	w0,#14		; cp hole length
	bra	nc,yesfall
2:			; //
	add	#4,w8		; adv hole table ptr
	dec	w9,w9
	bra	nz,9b	; /
	bra	nofall
yesfall:
;	mov	[w8],w0		; X pos rupe 0...173
;	cp	w0,#174
;	bra	c,nofall	; pokusaj ispravke laznih padova
	cp0	PLAYPTRJUMP
	bra	nz,nofall	; no fall, jump is in progress

	cp0	PLAYPTRDOWN
	bra	nz,nofall	; no fall, down is in progress

	cp0	PLAYPTRFALL
	bra	z,1f	; \	; jer pad nije u toku
	mov	#122-2,w0	; na kraj pada
	mov	w0,PLAYPTRFALL	; ako je pad u toku, neka bude na kraju
	bset	FLAG,#8	 	; FLAG,#8 = set ako je pad poceo dok lezi
1:			; /
	bset	FLAG,#7		; FLAG,#7 = FALL flag
	bclr	FLAG,#1		; FLAG,#1 = set if hit by enemy, clr if dropped thru hole
nofall:
	bra	farm
; </editor-fold>
; <editor-fold desc="movejack">

; /\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
;				Jack moves        ;
; /\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/

movejack:
;	mov	JACKY,w0
;	mov	w0,REALY

	btsc	F2,#0		; F2,#0 = signifies ceiling collision during jump in SHIELD state
	bra	shieldfall

	btsc	FLAG,#8		; set ako je naisao na rupu
	bra	fall3		; ako je prekinut rupom dok lezi, ide odmah na pad
	btsc	FLAG,#9		; signifies collision during jump
	bra	fall4		; pad zbog pogresnog skoka

	cp0	PLAYPTRJUMP
	bra	nz,tryup2
	cp0	PLAYPTRFALL
	bra	nz,fall2
	btsc	FLAG,#7		; FALL flag
	bra	fall
	cp0	PLAYPTRDOWN
	bra	nz,godown

	cp0	SPIDERCOUNT
	bra	nz,tryup
; </editor-fold>
; <editor-fold desc="JUMP">

;
;
;		JUMP
;
;

	btss	JACKMOVE,#4	; #4 = key A
	bra	tryleft
				; JUMP
	clr	SPRITECOUNT		; clear brojac faze pokreta
	clr	PLAYPTR			; clear brojac sekvence za cesanje po glavi dok stoji
	clr	PLAYPTRFALL		; clear brojac sekvence za pad

	mov	JACKY,w0
	cp	w0,#7
	manji
	return			; nema skokova na poslednjem spratu

	cp0	PLAYPTRJUMP
	ifz
	inc	PLAYPTRJUMP	; ovo inicira pocetak skoka

	tirli1	s.skok
tryup2:				; jack jumps up (auto reset bit when jump is over)
	mov	#SPRITELIST+17*12,w3	; Jack zauzima 18. sprajt (SPRITELIST+17*12)
	clr	SPRITECOUNT

	btss	VGAUNIFORM,#0
	bra	4f	; \	; usporava 2x eventualno horizontalno kretanje tokom skoka

	mov	#2,w0
	btss	JACKMOVE,#0	; flag za taster LEVO
	bra	3f		; nije pritisnut i taster LEVO
	sub	JACKX		; pomera X pointer nalevo za 2 pix, to je normalan step
	btsc	JACKX,#15
	add	JACKX		; ako je postao negativan, vraca ga na 0
3:
	btss	JACKMOVE,#1	; flag za taster DESNO
	bra	4f		; nije pritisnut i taster DESNO
	add	JACKX		; pomera X pointer nadesno za 2 pix, to je normalan step
	mov	JACKX,w0
	mov	#386-20,w1
	cpslt	w0,w1
	sub	JACKX		; ako je otisao suvise desno, vraca ga na max desno
4:			; /
	mov	JACKX,w0
	mov	w0,[w3++]		; +0  X pos sprajta (od leve ivice)
	mov	JACKY,w0
	mov	w0,[w3++]		; +2  Y pos sprajta (od GORNJE ivice)

	mov	#12,w0
	mov	w0,[w3++]		; +4  sirina sprajta
	mov	#30,w0
	mov	w0,[w3++]		; +6  visina sprajta

	mov	#psvoffset(jump),w2

	movpag	#tblpage(jumpseq),TBLPAG
	mov	PLAYPTRJUMP,w0
	sl	w0,#2,w0		; *4, jer jedan clan tabele ima 4 by
	mov	#tbloffset(jumpseq),w1
	add	w0,w1,w4		; point na tabelu
	tblrdl	[w4++],w0		; tu je addr sprajta iz tabele
	tblrdl	[w4++],w1		; tu je -Y offset iz tabele

	mov	[w3-6],w4		; Y pos
	sub	w4,w1,w4		; korekcija Y pos
	mov	w4,[w3-6]		; novi Y pos
;	mov	w4,REALY

	add	w0,w2,[w3++]		; +8  adresa sprajta u romu
	mov	#psvpage(jump),w0
	mov	w0,[w3++]		; +10  stranica

	inc	PLAYPTRJUMP
	mov	PLAYPTRJUMP,w0

	cp	w0,#46			; sekvenca traje od 0 do 45 frejma
	bra	nz,testrupe

	bclr	FLAG,#7		; FLAG,#7 = FALL flag (sigurnosni clr zbog baga na poslednjem spratu)

	clr	PLAYPTRJUMP
	mov	#34,w0
	sub	JACKY

	mov	#0xd3,w1
	mov	JACKY,w0
	cp	w0,w1
	ifc
	mov	w1,JACKY		; limitira JACKY nadole
	return		    ; *

testrupe:				; sledi test da li je zakacio rupu u skoku (w1=Yoffset tokom skoka)
	cp	w1,#15		; sprite No.
	bra	nc,passed		; ***TOLERANCIJA*** jer je prenisko
	cp	w1,#18		; sprite No.
	bra	c,passed		; ***TOLERANCIJA*** jer je previsoko

	mov	BROJRUPA,w9
	cp0	w9
	bra	z,knock	; \\	; jer je broj rupa =0
	mov	#RUPE,w8	; +0: hole X-pos 0...173 (>173: no hole), +2: line number 0...5 (>5: no hole)
9:			; \
	mov	[w8+2],w0	; tested hole's line number 0...5
	add	JACKFLOOR,WREG	; line on which the tested hole is (from the top) + floor on which jack is
	cp	w0,#6-1
	bra	nz,2f		; tested hole is NOT on jack's floor
	sl	[w8],w0		; 2x, makes hole X pos 0...346 (in pixels)
	add	#16-6,w0	; real position (skip elevator) - jack's X center (in pixels)
	mov	JACKX,w2	; jack's X pos 0...326 (in pixels)
	sub	w2,w0,w0	; jack's X offset from the left hole edge
	add	#8,w0		; ***TOLERANCIJA*** levo
	cp	w0,#14+16	; cp hole length (iza plusa je ***TOLERANCIJA*** levo+desno)
	bra	nc,passed	; passed thru hole
2:
	add	#4,w8		; adv hole table ptr
	dec	w9,w9
	bra	nz,9b	; /
knock:			; //
	clr	PLAYPTRJUMP
	bset	FLAG,#9		; signifies collision during jump
	bclr	FLAG,#1		; FLAG,#1 = set if hit by enemy, clr if dropped thru hole or collision during jump

	btss	FLAG,#15	; FLAG,#15 = shield
	return
	bset	F2,#0		; F2,#0 = signifies collision during jump in SHIELD state
	bclr	FLAG,#9
passed:
	return		    ; *

; </editor-fold>
; <editor-fold desc="WALK LEFT">
;
;
;		WALK LEFT
;
;

tryleft:
	btss	JACKMOVE,#0
	bra	tryright
				; jack moves left
	btsc	FLAG,#15	; bit 15 = shield on
	bra	1f		; nema usporavanja ako je shield on

	btss	F2,#4		; F2,#4 = set ako je jack u oblaku
	bra	1f		; nema usporavanja ako nije u oblaku
				; ovde je u oblaku
	btsc	VGAUNIFORM,#0
	return			; ovo ga usporava 2x
1:
	clr	PLAYPTR			; clear brojac sekvence za cesanje po glavi dok stoji
	clr	PLAYPTRJUMP		; clear brojac sekvence za skok
	clr	PLAYPTRFALL		; clear brojac sekvence za pad

	mov	JACKX,w0
	cp	w0,#5
	manji
	return			; limitira JACKX na minimum 4

	clr	PLAYPTR
	inc	SPRITECOUNT
	bclr	SPRITECOUNT,#4	; range 0...15
	dec2	JACKX		; ***** pomera X pointer nalevo za 2 pix, to je normalan step
	btsc	JACKX,#15
	inc2	JACKX		; ako je postao negativan, vraca ga na 0

;	testira da li je naisao na stop
	btsc	FLAG,#15	; bit 15 = shield on
	bra	1f		; nema prepreka kad je shield on

	mov	JACKFLOOR,w0	; sprat na kome se nalazi Jack (0=skroz dole)
	mov	#STOP6X,w3	; taj je prvi u tabeli
	cp0	w0
	bra	z,1f		; jer na zemlji nema stopova
	dec	w0,w0		; jer ce sprat krenuti od 1 a ne od 0
	sl	w0,w0		; *2
	add	w3,w0,w3
	mov	[w3],w1		; tu je X pos stopa na tom spratu
	cp0	w1
	bra	z,1f		; jer na tom spratu ne postoji stop
	mov	JACKX,w3
	bclr	w3,#0
	bclr	w3,#1
	add	#12,w1		; dotle Jack sme da dodje zdesna
	cp	w3,w1
	ifz
	inc2	JACKX		; ***** vraca ga desno jer je udario u stop
1:
; crta sprajt Jacka koji hoda levo
	mov	#SPRITELIST+17*12,w3	; Jack zauzima 18. sprajt (SPRITELIST+17*12)

	mov	JACKX,w0
	sub	#4,w0			; jer je sprite siri nego dok stoji
	dec	w0,w0			; radi sinhronizacije sa mikropolozajem jacka u sprajtovima
	mov	w0,[w3++]		; +0  X pos sprajta (od leve ivice)
	mov	JACKY,w0
	mov	w0,[w3++]		; +2  Y pos sprajta (od GORNJE ivice)

	mov	#20,w0
	mov	w0,[w3++]		; +4  sirina sprajta
	mov	#27,w0
	mov	w0,[w3++]		; +6  visina sprajta

	mov	SPRITECOUNT,w0
	mov	#20*27/2,w2
	mulw.uu	w0,w2,w2		; to je offset od 1. do (JACKX) sprajta
	mov	#psvoffset(walkleft),w0
	add	w0,w2,[w3++]		; +8  adresa sprajta u romu
	mov	#psvpage(walkleft),w0
	mov	w0,[w3++]		; +10  stranica na kojoj je sprajt u romu

	return
; </editor-fold>
; <editor-fold desc="WALK RIGHT">
;
;
;		WALK RIGHT
;
;

tryright:
	btss	JACKMOVE,#1
	bra	trydown
				; jack moves right
	btsc	FLAG,#15	; bit 15 = shield on
	bra	1f		; nema usporavanja ako je shield on

	btss	F2,#4		; F2,#4 = set ako je jack u oblaku
	bra	1f
				; ovde je u oblaku
	btsc	VGAUNIFORM,#0
	return			; ovo ga usporava 2x
1:
	clr	PLAYPTR			; clear brojac sekvence za cesanje po glavi dok stoji
	clr	PLAYPTRJUMP		; clear brojac sekvence za skok
	clr	PLAYPTRFALL		; clear brojac sekvence za pad

	clr	PLAYPTR
	inc	SPRITECOUNT
	bclr	SPRITECOUNT,#4	; range 0...15
	inc2	JACKX		; pomera X pointer nadesno za 2 pix, to je normalan step
	mov	JACKX,w0
	sub	#4,w0		; jer je sprite siri nego dok stoji
	mov	#386-20,w1
	cpslt	w0,w1
	dec2	JACKX		; ako je otisao suvise desno, vraca ga na max desno

;	testira da li je naisao na stop
	btsc	FLAG,#15	; bit 15 = shield on
	bra	1f		; nema prepreka kad je shield on

	mov	JACKFLOOR,w0	; sprat na kome se nalazi Jack (0=skroz dole)
	mov	#STOP6X,w3	; taj je prvi u tabeli
	cp0	w0
	bra	z,1f		; jer na zemlji nema stopova
	dec	w0,w0		; jer ce sprat krenuti od 1 a ne od 0
	sl	w0,w0		; *2
	add	w3,w0,w3
	mov	[w3],w1		; tu je X pos stopa na tom spratu
	cp0	w1
	bra	z,1f		; jer na tom spratu ne postoji stop
	mov	JACKX,w3
	bclr	w3,#0
	bclr	w3,#1
	sub	#8,w1		; dotle Jack sme da dodje sleva
	cp	w3,w1
	ifz
	dec2	JACKX		; ***** vraca ga levo jer je udario u stop
1:
; crta sprajt Jacka koji hoda levo
	mov	#SPRITELIST+17*12,w3	; Jack zauzima 18. sprajt (SPRITELIST+17*12)

	mov	JACKX,w0
	mov	w0,[w3++]		; +0  X pos sprajta (od leve ivice)
	mov	JACKY,w0
	mov	w0,[w3++]		; +2  Y pos sprajta (od GORNJE ivice)

	mov	#20,w0
	mov	w0,[w3++]		; +4  sirina sprajta
	mov	#27,w0
	mov	w0,[w3++]		; +6  visina sprajta

	mov	SPRITECOUNT,w0
	mov	#20*27/2,w2
	mulw.uu	w0,w2,w2		; to je offset od 1. do (JACKX) sprajta
	mov	#psvoffset(walkright),w0
	add	w0,w2,[w3++]		; +8  adresa sprajta u romu
	mov	#psvpage(walkright),w0
	mov	w0,[w3++]		; +10  stranica na kojoj je sprajt u romu

	return
; </editor-fold>
; <editor-fold desc="UP (SPIDERMAN)">
;
;
;		SPIDERMAN
;
;

tryup:					; ovde dolazi samo ako je SPIDERCOUNT > 0

	clr	PLAYPTR			; clear brojac sekvence za cesanje po glavi dok stoji

; crta sprajt Spidermana

	mov	#SPRITELIST+17*12,w3	; Jack zauzima 18. sprajt (SPRITELIST+17*12)

	mov	JACKX,w0
	sub	#4,w0			; jer je spiderman sprite siri za 8 pix
	mov	w0,[w3++]		; +0  X pos sprajta (od leve ivice)
	mov	JACKY,w0
	sub	#4,w0			; jer je spiderman sprite visi za 4 pix
	mov	w0,[w3++]		; +2  Y pos sprajta (od GORNJE ivice)

	mov	#20,w0
	mov	w0,[w3++]		; +4  sirina sprajta
	mov	#31,w0
	mov	w0,[w3++]		; +6  visina sprajta

	mov	SPIDERCOUNT,w0
	mov	#31*20/2,w2
	mulw.uu	w0,w2,w2		; to je offset od 1. do (JACKX) sprajta
	mov	#psvoffset(spiderman),w0
	add	w0,w2,[w3++]		; +8  adresa sprajta u romu
	mov	#psvpage(spiderman),w0
	mov	w0,[w3++]		; +10  stranica na kojoj je sprajt u romu

	return
; </editor-fold>
; <editor-fold desc="DOWN">
trydown:
	btss	JACKMOVE,#3
	bra	stands
	cp0	JACKFLOOR	; na tom spratu je fizicki jack
	bra	z,stands	; nema silaska sa prizemlja
				; jack jumps (not falls) down					
	tirli1	s.down
	mov	#1,w0		; za iniciranje pocetka pada
	mov	w0,PLAYPTRDOWN
godown:				; jack skace dole (ne pada)
	clr	SPRITECOUNT		; clear brojac faze pokreta
	clr	PLAYPTR			; clear brojac sekvence za cesanje po glavi dok stoji
	clr	PLAYPTRJUMP		; clear brojac sekvence za skok
	mov	#SPRITELIST+17*12,w3	; Jack zauzima 18. sprajt (SPRITELIST+17*12)

	mov	JACKX,w0
	sub	#4,w0
	mov	w0,[w3++]		; +0  X pos sprajta (od leve ivice)
	mov	JACKY,w0
	sub	#4,w0
	mov	w0,[w3++]		; +2  Y pos sprajta (od GORNJE ivice)

	mov	#20,w0
	mov	w0,[w3++]		; +4  sirina sprajta
	mov	#31,w0
	mov	w0,[w3++]		; +6  visina sprajta

	movpag	#tblpage(downseq),TBLPAG
	mov	PLAYPTRDOWN,w0
	sl	w0,#2,w0		; *4, jer jedan clan tabele ima 4 by
	mov	#tbloffset(downseq),w1
	add	w0,w1,w4		; point na tabelu
	tblrdl	[w4++],w0		; tu je addr sprajta iz tabele
	tblrdl	[w4++],w1		; tu je +Y offset iz tabele

	mov	[w3-6],w4		; Y pos
	add	w4,w1,w4		; korekcija Y pos

	mov	#240-27,w1
	cp	w4,w1			; da li je Jack prenisko u video mem?
	istiveci
	mov	w1,w4			; limitira visinu sprajta da ne padne jack ispod donjeg nivoa

	mov	w4,[w3-6]		; novi Y pos
;	mov	w4,REALY

	mov	#psvoffset(spiderman),w2
	add	w0,w2,[w3++]		; +8  adresa sprajta u romu
	mov	#psvpage(spiderman),w0
	mov	w0,[w3++]		; +10  stranica

	inc	PLAYPTRDOWN		; + pointer
	mov	PLAYPTRDOWN,w0
	cp	w0,#49-18	;(downseqend-downseq)/4			; toliko frejmova traje sekvenca
	ifnz
	return
	clr	PLAYPTRDOWN

	mov	JACKY,w0
	add	#34,w0
	mov	w0,JACKY

	mov	#0xd3,w1
	mov	JACKY,w0
	cp	w0,w1
	ifc
	mov	w1,JACKY		; limitira JACKY nadole
	return
; </editor-fold>
; <editor-fold desc="STAND/SCRATCH">
;
;
;		STAND/SCRATCH
;
;

stands:				; jack stands
	mov	#SPRITELIST+17*12,w3	; Jack zauzima 18. sprajt (SPRITELIST+17*12)
	clr	SPRITECOUNT		; clear brojac faze pokreta
	clr	PLAYPTRJUMP		; clear brojac sekvence za skok
	clr	PLAYPTRFALL		; clear brojac sekvence za pad

	mov	JACKX,w0
	and	#0b0111111100,w0
	mov	w0,JACKX
	mov	w0,[w3++]		; +0  X pos sprajta (od leve ivice)
	mov	JACKY,w0
	mov	w0,[w3++]		; +2  Y pos sprajta (od GORNJE ivice)

	mov	#12,w0
	mov	w0,[w3++]		; +4  sirina sprajta
	mov	#27,w0
	mov	w0,[w3++]		; +6  visina sprajta

	cp0	PLAYPTR
	bra	nz,goplay

	btss	F2,#4
	bra	nomoment		; nema cesanja ako nije u oblaku

	call	rnd
	and	#127,w0			; ucestalost cesanja po glavi
	bra	nz,nomoment
	mov	SEED+2,w0
	mov	w0,LASTSEED
goplay:					; trenutak za iniciranje sekvence cesanja po glavi
	mov	#psvoffset(standleft),w2
	btss	LASTSEED,#0
	mov	#psvoffset(standright),w2	; sad je i levo-desno randomizirano

	movpag	#tblpage(standseq),TBLPAG
	sl	PLAYPTR,WREG		; *2, jer jedan clan tabele ima 2 by
	mov	#tbloffset(standseq),w1
	add	w0,w1,w0		; point na tabelu
	tblrdl	[w0],w0			; tu je offset iz tabele
	add	w0,w2,[w3++]		; +8  adresa sprajta u romu
	mov	#psvpage(standleft),w0
	mov	w0,[w3++]		; +10  stranica (standleft i standright su na istoj stranici)

	inc	PLAYPTR
	bclr	PLAYPTR,#6		; sekvenca traje od 0...63
	return

nomoment:				; ovde samo stoji i ne pomera se
	mov	#psvoffset(standleft),w0
	mov	w0,[w3++]		; +8  adresa sprajta u romu
	mov	#psvpage(standleft),w0
	mov	w0,[w3++]		; +10  stranica na kojoj je sprajt u romu

	return
; </editor-fold>
; <editor-fold desc="FALL">
;
;
;		FALL
;
;

fall4:				; pad zbog pogresnog skoka
	mov	JACKY,w0
	sub	#34,w0
	mov	w0,JACKY
	bclr	FLAG,#9
	mov	#23,w0		; da ne pocne bas od pocetka jer je pad nastao u skoku
	bra	1f
fall3:				; ako je prekinut rupom dok lezi, ide odmah na pad
	mov	JACKY,w0
	add	#34,w0
	cp	w0,#0xd3
	ifnc
	mov	w0,JACKY
fall:				; ovde dolazi ako je iniciran pad setovanim FLAG,#7
	clr	SPRITECOUNT		; clear brojac faze pokreta
	clr	PLAYPTR			; clear brojac sekvence za cesanje po glavi dok stoji
	clr	PLAYPTRJUMP		; clear brojac sekvence za skok

	tirli1	s.pad

	mov	#1,w0		; za iniciranje pocetka pada
	btss	FLAG,#8
	bra	1f
	bclr	FLAG,#8
	mov	#12,w0		; da ne pocne bas od pocetka, da ne ustaje ako je zakacen rupom dok lezi
1:
	mov	w0,PLAYPTRFALL
fall2:				; jack pada
	bclr	FLAG,#7		; FALL flag
	mov	#SPRITELIST+17*12,w3	; Jack zauzima 18. sprajt (SPRITELIST+17*12)
	clr	SPRITECOUNT

	mov	JACKX,w0
	mov	w0,[w3++]		; +0  X pos sprajta (od leve ivice)
	mov	JACKY,w0
	mov	w0,[w3++]		; +2  Y pos sprajta (od GORNJE ivice)

	mov	#24,w0
	mov	w0,[w3++]		; +4  sirina sprajta
	mov	#27,w0
	mov	w0,[w3++]		; +6  visina sprajta

	movpag	#tblpage(fallseq),TBLPAG
	mov	PLAYPTRFALL,w0
	sl	w0,#2,w0		; *4, jer jedan clan tabele ima 4 by
	mov	#tbloffset(fallseq),w1
	add	w0,w1,w4		; point na tabelu
	tblrdl	[w4++],w0		; tu je addr sprajta iz tabele
	tblrdl	[w4++],w1		; tu je +Y offset iz tabele

	mov	[w3-6],w4		; Y pos
	add	w4,w1,w4		; korekcija Y pos

	mov	#240-27,w1
	cp	w4,w1			; da li je Jack prenisko u video mem?
	istiveci
	mov	w1,w4			; limitira visinu sprajta da ne padne jack ispod donjeg nivoa

	mov	w4,[w3-6]		; novi Y pos
;	mov	w4,REALY

	mov	#psvoffset(fallspr),w2
	add	w0,w2,[w3++]		; +8  adresa sprajta u romu
	mov	#psvpage(fallspr),w0
	mov	w0,[w3++]		; +10  stranica

	inc	PLAYPTRFALL

	mov	PLAYPTRFALL,w0
	cp	w0,#45			; tu pocinju zvezdice
	bra	nz,noticstars
;	

	btsc	FLAG,#1		; FLAG,#1 = set if hit by enemy, clr if dropped thru hole
	bra	loseslife		; loses life, because he was hit by enemu

	mov	#0xd3-40,w1
	mov	JACKY,w0
	cp	w0,w1
	bra	nc,nolostlife		; ne gubi zivot jer je na spratu
loseslife:
	cp0	LIVES
	ifnz
	dec	LIVES			; izgubljen jedan zivot
	mov	#133,w0
	mov	w0,BLUELIVES
	call	printlives

	cp0	LIVES
	bra	nz,nolostlife
; ispisuje "GAME OVER"
	mov	#100,w4		; X pos podloge natpisa "GAME OVER"
	mov	#96-34,w5	; Y pos podloge natpisa "GAME OVER"
	mov	#180,w6		; sirina
	mov	#83,w7		; visina 2 sprata
	mov	#0b0011000000110000,w3	; tamno plavo
	call	podloga		; podloga za "GAME OVER"

	mov	#0b11111111,w0	; ink beo
	mov	w0,INK
	asciiprint	146,115-34,gameendpor	; ispisuje poruku  "GAME OVER"  na sredini podloge

	mov	#0b11111100,w0	; ink lt cy
	mov	w0,INK
	asciiprint	126,115,pressanykeypor	; ispisuje poruku  "PRESS ANY KEY"  na sredini podloge

	mov	#6*34+2,w0
	mov	w0,CLOUDTARGETY	; zove oblak

	mov	JACKX,w0
	sub	#24,w0		; toliko je od sredine jacka do sredine clouda
	mov	w0,CLOUDTARGETX	; zove oblak

;	mov	#30,w0
;	mov	w0,CEKALICA	; da pola sekunde ignorise tastere

	mov	#KEYROTORS,w3
	repeat	#6-1
	clr	[w3++]		; debouncer reset

	bset	F2,#8		; bit 8 = set ako je game over (0 lives)
nolostlife:
;	
	call	rnd
	and	#3,w0
	bra	z,tics1
	cp	w0,#1
	bra	z,tics2
	cp	w0,#2
	bra	z,tics3
	tirli1	ticstars1
	bra	noticstars
tics1:
	tirli1	ticstars2
	bra	noticstars
tics2:
	tirli1	ticstars3
	bra	noticstars
tics3:
	tirli1	ticstars4
noticstars:
;	ako nema vise zivota, vrte se frejmovi 46-53 (zvezdice)
	mov	PLAYPTRFALL,w0
	cp	w0,#56
	bra	nz,1f
	mov	#46,w0
	cp0	LIVES
	ifz
	mov	w0,PLAYPTRFALL		; da bi se zaustavio na zemlji ako nema vise zivota (zvezdice 54 --> 46)
1:
;	
	mov	PLAYPTRFALL,w0
	cp	w0,#146			; toliko frejmova traje sekvenca
	ifnz
	return
	clr	PLAYPTRFALL

	mov	JACKY,w0
	add	#34,w0
	mov	w0,JACKY

	mov	#0xd3,w1
	mov	JACKY,w0
	cp	w0,w1
	ifc
	mov	w1,JACKY		; limitira JACKY nadole
	return
; </editor-fold>
; <editor-fold desc="SHIELDED FALL">
;
;
;		SHIELDED FALL
;
;										

shieldfall:			; pad pod shieldom
	clr	SPRITECOUNT		; clear brojac faze pokreta
	clr	PLAYPTR			; clear brojac sekvence za cesanje po glavi dok stoji
	clr	PLAYPTRJUMP		; clear brojac sekvence za skok
	clr	SPRITECOUNT

	mov	#SPRITELIST+17*12,w3	; Jack zauzima 18. sprajt (SPRITELIST+17*12)

	mov	JACKX,w0
	mov	w0,[w3++]		; +0  X pos sprajta (od leve ivice)
	mov	JACKY,w0
	sub	#3,w0			; jer je toliko veca visina sprajta
	mov	w0,[w3++]		; +2  Y pos sprajta (od GORNJE ivice)

	mov	#12,w0
	mov	w0,[w3++]		; +4  sirina sprajta
	mov	#30,w0
	mov	w0,[w3++]		; +6  visina sprajta

	mov	#psvoffset(smalljump),w2

	movpag	#tblpage(maliskok),TBLPAG
	mov	PLAYPTRFALLSH,w0
	lsr	w0,w0			; /2, jer svaki sprite traje po 2 frejma
	sl	w0,w0			; *2, jer jedan clan tabele ima 2 by
	mov	#tbloffset(maliskok),w1
	add	w0,w1,w4		; point na tabelu
	tblrdl	[w4++],w0		; tu je addr sprajta iz tabele

	add	w0,w2,[w3++]		; +8  adresa sprajta u romu
	mov	#psvpage(smalljump),w0
	mov	w0,[w3++]		; +10  stranica

	inc	PLAYPTRFALLSH
	mov	PLAYPTRFALLSH,w0
	cp	w0,#14			; toliko frejmova traje sekvenca
	ifnz
	return
	clr	PLAYPTRFALLSH
	bclr	F2,#0			; F2,#0 = signifies collision during jump in SHIELD state

	return
; </editor-fold>
; <editor-fold desc="INCLUDES">
.include "vga.inc"		; must be on page page 0
.include "menu.inc"		; must be on page page 0
.include "subs.inc"		; must be on page page 0
.include "sound.inc"	; must be on page page 0
.include "jagger.inc"	; must be on page page 0
.include "tables.inc"	; must be on page page 0

.org	0x10000
.include "sprites1.inc"	; (bridges.inc must be in 64K range)
										; bridges:		; 380x240 background	45600 by
										; jump:			; 12x30, 14 frames
										; standleft:	; 12x27, 10 frames
										; standright:	; 12x27, 10 frames
										; walkleft:		; 20x27, 16 frames
										; walkright:	; 20x27, 16 frames
										; liftright:	; 8x27, 1 frame
										; liftleft:		; 8x27, 1 frame
										; stop1:		; 16x28, 1 frame
										; stop2:		; 16x28, 1 frame
										; stop3:		; 16x28, 1 frame
										; stop4:		; 16x28, 1 frame
										; stop5:		; 16x28, 1 frame
										; stop6:		; 16x28, 1 frame
										; stop4a:		; 8x5, 1 frame
										; stop4b:		; 8x5, 1 frame
										; adjsq1:		; 20x20  beli kvadrat za podesavanje
										; adjsq2a:		; 32x20  beli kvadrat za podesavanje
										; adjsq2b:		; 32x20  beli kvadrat za podesavanje, pomeren 2 piksela desno
										; adjsq3:		; 40x20  beli kvadrat za podesavanje, pomeren 2 piksela desno
										; adjsq4:		; 52x20  beli kvadrat za podesavanje

.org	0x20000
.include "sprites2.inc"	; must be in 32K range
										; ufo1:			; 52x52, 12 frames	16224 by
										; fallspr:		; 24x27, 45 frames	14580 by
.org	0x28000
.include "sprites3.inc"	; must be in 32K range
										; lightningspr:	; 40x31, 52 frames	29760 by
.org	0x30000
.include "sprites4.inc"	; must be in 32K range
										; para:			; 48x14, 64 frames	18432 by
										; pogoleft:		; 16x30, 52 frames	12480 by
.org	0x38000
.include "sprites5.inc"	; must be in 32K range
										; pogoright:	; 16x30, 52 frames	12480 by
										; spiderman:	; 20x31, 12 frames	 3720 by
										; nogeleft:		; 32x27, 16 frames	 6912 by
										; nogeright:	; 32x27, 16 frames	 6912 by
										; smalljump:	; 12x30, 7 frames	 1280 by

.org	0x40000
.include "sprites6.inc"	; must be in 32K range
										; cube:		; 24x20, 100 frames	24000 by
.org	0x48000
.include "sprites7.inc"	; must be in 32K range
										; pillar:		; 52x10, 48 frames	12480 by
										; padalice:	; svaka tabela po 16x24, 16 frames (po 3072 by)

; </editor-fold>
	.end
